/*------------------------------------------------------------------*/
/*      Copyright (c)      Softing AG 2008                          */
/*      Product:           EDD for CiDRA SONATR                     */
/*                                                                  */
/*      Device:            CiDRA SONAR     PA 2.20                  */
/*                                                                  */
/*      Communication:     PROFIBUS PA                              */
/*      Description:       EDD                                      */
/*      Dictionary:                                                 */
/*      Revision           1.00                                     */
/*      Date:              2008/06/18                               */
/*      Author:            SHR                                      */
/*------------------------------------------------------------------*/

#define DEVICE_TYPE "CiDRA SONAR"

#include "sonar_phy.inc"
#include "sonar_gen.inc"
#include "sonar_aifb.inc"
#include "sonar_aifb_2.inc"
#include "sonar_aifb_3.inc"
#include "sonar_aifb_4.inc"
#include "sonar_aifb_5.inc"
#include "sonar_aifb_6.inc"
#include "sonar_aifb_7.inc"
#include "sonar_aifb_8.inc"
#include "sonar_aifb_9.inc"
#include "sonar_aofb.inc"
#include "sonar_aofb_2.inc"
#include "sonar_aofb_3.inc"
#include "sonar_aofb_4.inc"
#include "sonar_aofb_5.inc"
#include "sonar_tb.inc"


/***************************************************************************/
/*****  MENU Bar     *******************************************************/
/***************************************************************************/
MENU Menu_Main_Specialist
{
    LABEL       [main_menu];
    ITEMS
    {
        Menu_File,
        Menu_S_Device,
        Menu_S_View,
        Menu_Options,
        Menu_Help
    }
}

MENU Menu_Main_Maintenance
{
    LABEL       [main_menu];
    ITEMS
    {
        Menu_File,
        Menu_M_Device,
        Menu_M_View,
        Menu_Options,
        Menu_Help
    }
}

/*-------------------------------------------------------------------------*/
/******** Menu_S_Device ****************************************************/
/*-------------------------------------------------------------------------*/
MENU Menu_S_Device
{
    LABEL   [menu_Device];
    ITEMS
    {
        std_NodeAddress,
        SEPARATOR,
        std_LoadinDevice,
        std_LoadinPC, 
        SEPARATOR,
        Menu_online,
        Menu_offline,
        SEPARATOR,
        Menu_cal,
        SEPARATOR,
        Menu_maintenance,
        Menu_factory
    }
}

/*-------------------------------------------------------------------------*/
/********** Menu_online ****************************************************/
MENU Menu_online
{
    LABEL "Online Configuration";
    ITEMS
    {
        OnlineDialog_Phy_Info,
        Menu_AI_on
    }
}

/*--------- OnlineDialog_Phy_Info -----------------------------------------*/
MENU OnlineDialog_Phy_Info
{
    LABEL   "Device Info";
    ITEMS
    {
        Page_Phy_Info,
    }
}

MENU Page_Phy_Info
{
    LABEL    "Device Info";
    ITEMS
    {
        phys_tag_desc,
        phys_message,
        phys_descriptor,
        phys_install_date, 
        method_set
    }
}

/*-------------------------------------------------------------------------*/
/*--------- Menu_AI_on ----------------------------------------------------*/

MENU Menu_AI_on
{
    LABEL   "Analog Input";
    ITEMS
    {
        OnlineDialog_AI_setting
    }
}

MENU OnlineDialog_AI_setting
{
    LABEL   "AI Block Mode";
    ITEMS
    {
        Page_mode_ai
    }
}

MENU Page_mode_ai
{
    LABEL   "Config Block Mode";
    ITEMS                              
    {
        Group_mode_ai,
        Group_AI_out_value,
        aifb_current_state_alarm_sum,
        method_set
    }
}

MENU Group_mode_ai
{
    LABEL   "Set Target Mode";
    ITEMS
    {
        aifb_target_mode,
        SEPARATOR,
        aifb_actual_mode
    }
}

MENU Group_AI_out_value
{
    LABEL   "Output";
    ITEMS
    {
        aifb_out_value,
        SEPARATOR,
        aifb_out_status (READ_ONLY)
    }
}

/*---------------------------------------------------------------------*/
/********** Menu_offline ***********************************************/

MENU Menu_offline
{
    LABEL   "Offline Configuration";
    ITEMS
    {
        OfflineWindow_AI_geral
    }
}

/*---------------------------------------------------------------------*/
/*--------- OfflineWindow_AI_geral ------------------------------------*/

MENU OfflineWindow_AI_geral
{
    LABEL   "Analog Input"; 
    ITEMS
    {
        Page_basic_ai,
        Page_advanced_ai,
        Page_batch_ai
    }
}

MENU Page_basic_ai
{
    LABEL   "AI Basic Setting";
    ITEMS
    {
        Group_target_mode_ai, 
        Group_channel_ai,
        Group_scale_pv_ai,
        Group_scale_out_ai,
        Group_damping_ai
    }
}

MENU Page_advanced_ai
{
    LABEL   "AI Advanced Setting";
    ITEMS
    {
        Group_alarm_limits_ai,
        Group_fault_set_ai
    }
}

MENU Page_batch_ai
{
    LABEL   "AI Batch";
    ITEMS
    {
        Group_batch_ai
    }
}

/*--------- Submenu of Page_basic_ai ------------------------------*/
MENU Group_target_mode_ai
{
    LABEL   "AI Mode Setting";
    ITEMS
    {
        aifb_target_mode,
        SEPARATOR,
        method_write_target_mode_ai
    }
}

MENU Group_channel_ai
{
    LABEL   "AI Channel Setting";
    ITEMS
    {
        aifb_channel,
        SEPARATOR,
        method_write_channel_ai                
    }
}

MENU    Group_scale_pv_ai
{
    LABEL "AI PV Scale";
    ITEMS
    {
        aifb_pv_upper_range_value,
        aifb_pv_lower_range_value,
        SEPARATOR,
        method_write_scale_pv_ai
    }
}

MENU    Group_scale_out_ai
{
    LABEL "AI OUT Scale";
    ITEMS
    {
        aifb_out_upper_range_value,
        aifb_out_lower_range_value,
        aifb_out_unit,
        SEPARATOR,
        method_write_scale_out_ai
    }
}

MENU Group_damping_ai
{
    LABEL "AI Damping";
    ITEMS
    {
        aifb_pv_ftime,
        SEPARATOR,
        method_write_damping_ai
    }
}

/*--------- Submenu of Page_advanced_ai -----------------------------*/

MENU Group_alarm_limits_ai
{
    LABEL   "AI Alarm Limits";
    ITEMS
    {
        aifb_hi_hi_lim,
        aifb_hi_lim,
        aifb_lo_lo_lim,
        aifb_lo_lim,
        aifb_alarm_hys,
        aifb_out_unit (READ_ONLY),
        SEPARATOR,
        method_write_limit_ai
    }
}

MENU Group_fault_set_ai
{
    LABEL   "AI Fail Safe Type";
    ITEMS
    {
        aifb_FSafeType,
        aifb_FSafeValue,
        SEPARATOR,
        method_write_fail_ai
    }
}

/*--------- Submenu of Page_batch_ai ----------------------------------*/

MENU Group_batch_ai
{
    LABEL "AI Batch";
    ITEMS
    {
        aifb_batch_id,
        aifb_batch_unit,
        aifb_batch_operation,
        aifb_batch_phase,
        SEPARATOR,
        method_write_batch_ai
    }
}

/*---------------------------------------------------------------------*/
/********** Menu_maintenance *******************************************/
/*---------------------------------------------------------------------*/
MENU Menu_maintenance
{
    LABEL "Maintenance";
    ITEMS
    {
        OnlineDialog_write_locking,  
        OnlineDialog_simulation_ai   
    }
}
/*---------------------------------------------------------------------*/
/*--------- OnlineDialog_write_locking --------------------------------*/

MENU OnlineDialog_write_locking
{
    LABEL   "Write Protection";
    HELP    [phys_write_locking_help];
    ITEMS
    {
        phys_write_locking,
/*      phys_hw_write_protection, */
        method_set
    }
}


/*--------- OnlineDialog_simulation_ai --------------------------------*/

MENU OnlineDialog_simulation_ai
{
    LABEL   "Simulate AI";
    ITEMS
    {
        Page_simulation_input_ai,
        Page_simulation_output_ai
    }
}

MENU Page_simulation_input_ai
{
    LABEL   "AI Simulation (Measured Value)";  /* [menu_dialog_simulation_input]; */
    ITEMS
    {
        aifb_simulation_enabled,
        Group_simulate_input_ai,
        method_set
    }
}

MENU Group_simulate_input_ai
{
    LABEL   "Simulation Value";     /*[func_simulate_value];*/
    ITEMS
    {
        aifb_simulate_value,
        SEPARATOR,
        aifb_simulate_status
    }
}

MENU Page_simulation_output_ai
{
    LABEL   "Simulation (Output)";  /* [menu_dialog_simulation_output]; */
    ITEMS
    {
        Group_mode_ai,
        Group_simulate_output_ai,
        method_set
    }
}

MENU Group_simulate_output_ai
{
    LABEL   "Output Value";     /* [func_out_value]; */
    ITEMS
    {
        aifb_out_value,
        SEPARATOR,
        aifb_out_status
    }
}

/*---------------------------------------------------------------------*/
/********** Menu_factory ***********************************************/
/*---------------------------------------------------------------------*/

MENU Menu_factory
{
    LABEL   "Factory";
    ITEMS
    {
        OnlineDialog_reset,
        OnlineDialog_characterization, 
        OnlineDialog_ident_number
    }
}

/*---------------------------------------------------------------------*/
/*    OnlineDialog: Reset                                              */
/*---------------------------------------------------------------------*/
/*-------------- OnlineDialog_reset -----------------------------------*/

MENU OnlineDialog_reset
{
    LABEL   [reset];
    ITEMS
    {
        Page_reset_device
    }
}

MENU Page_reset_device
{
    LABEL   "Factory Reset";       
    HELP    "Reset of the field device"; 
    ITEMS
    {
        phys_factory_reset,
        phys_diagnosis,
        method_set
    }
}


/*---------------------------------------------------------------------*/
/*-------------- OnlineDialog_ident_number ----------------------------*/

MENU OnlineDialog_ident_number
{
    LABEL   "IDENT_NUMBER Setting";
    HELP    "Set Device's Ident Number, device's reset followed";
    ITEMS
    {
        phys_ident_number,
        method_set
    }
}

/*-------------------------------------------------------------------*/
/*-------------------------------------------------------------------*/
/******** Menu_M_Device **********************************************/
/*-------------------------------------------------------------------*/

MENU Menu_M_Device
{
    LABEL   [menu_Device];
    ITEMS
    {
        std_NodeAddress,
        SEPARATOR,
        Menu_updown,
        SEPARATOR,
        Menu_startup,
        Menu_cal
    }
}
/*-------------------------------------------------------------------*/
MENU Menu_startup
{
    LABEL   "Startup";
    ITEMS
    {
        AITB_Setting,
        Menu_AI_conf
    }
}

MENU Menu_AI_conf
{
    LABEL   "Analog Input";
    ITEMS
    {
        OfflineWindow_AI_geral,
        OnlineDialog_AI_setting
    }
}
/*-------------------------------------------------------------------*/
/*-------------------------------------------------------------------*/
/******** Menu_S_View ** Menu_M_View *********************************/
/*-------------------------------------------------------------------*/

MENU Menu_S_View
{
    LABEL       [menu_View];
    ITEMS
    {
        OnlineWindow_display,
        OnlineWindow_diagnosis,
        Menu_S_alarm,
        OnlineWindow_st_rev,
        SEPARATOR,
        std_Funktionsleiste,
        std_Statuszeile,
        SEPARATOR,
        std_Update
    }
}

MENU Menu_M_View
{
    LABEL       [menu_View];
    ITEMS
    {
        OnlineWindow_display,
        OnlineWindow_diagnosis,
        OnlineWindow_M_alarm,
        SEPARATOR,
        std_Funktionsleiste,
        std_Statuszeile,
        SEPARATOR,
        std_Update
    }
}
/*-------------------------------------------------------------------*/
/*-------------- OnlineWindow_display -------------------------------*/

MENU OnlineWindow_display
{
    LABEL   "Monitoring";
    ITEMS
    {
        Page_display_AITB,
        Page_display_AI  
    }
}
/*-------------------------------------------------------------------*/
MENU Page_display_AITB
{
    LABEL   "AI Transducer";
    ITEMS
    {
        BarVal_out_display_AITB,
        Group_display_AITB_out,
    }
}

MENU BarVal_out_display_AITB
{
    LABEL   "AITB Primary Value";
    ITEMS
    {
        trans1_primary_value    (READ_ONLY)
    }
}

MENU Group_display_AITB_out
{
    LABEL   "Primary Value (Out)";
    ITEMS
    {
        trans1_primary_value    (READ_ONLY),
        SEPARATOR,
        trans1_primary_status   (READ_ONLY)
    }
}

/*-------------------------------------------------------------------*/
MENU Page_display_AI
{
    LABEL   "Analog Input";
    ITEMS
    {
        BarVal_out_display_AI,
        Group_display_AI_out
    }
}

MENU BarVal_out_display_AI
{
    LABEL   "AIFB Output";
    ITEMS
    {
        aifb_out_value      (READ_ONLY),
        aifb_out_lower_range_value  (READ_ONLY),
        aifb_out_upper_range_value  (READ_ONLY)
    }
}

MENU Group_display_AI_out
{
    LABEL   "AIFB Output";
    ITEMS
    {
        aifb_out_value      (READ_ONLY),
        SEPARATOR,
        aifb_out_status     (READ_ONLY)
    }
}
/*-------------------------------------------------------------------*/
/*-------------- OnlineWindow_diagnosis -----------------------------*/

MENU OnlineWindow_diagnosis
{
    LABEL   "Diagnosis";        /* [menu_dialog_diagnosis]; */
    ITEMS
    {
        Page_diagnosis_general, 
        Page_diagnosis_profile
    }
}
/*-------------------------------------------------------------------*/
MENU Page_diagnosis_general
{
    LABEL   "General diagnosis";    /* [menu_dialog_general]*/
    ITEMS
    {
        phys_tag_desc(READ_ONLY),
        phys_device_man_id,
        phys_device_id,
        phys_device_ser_num,
        phys_software_rev,
        phys_hardware_rev,
        phys_install_date,
        phys_diagnosis
    }
}
/*-------------------------------------------------------------------*/
MENU Page_diagnosis_profile
{
    LABEL   "Profile";      /* [blk_profile]; */
    ITEMS
    {
        phys_blk_profile,
        phys_blk_profile_rev,
        Group_diagnosis_st_rev
    }
}

MENU Group_diagnosis_st_rev
{
    LABEL   "Static Revision";  /* [st_rev]; */
    ITEMS
    {
        phys_st_rev,
        trans1_st_rev,
        aifb_st_rev
    }
}
/*-------------------------------------------------------------------*/
/*-------------- Menu_S_alarm ---------------------------------------*/
MENU Menu_S_alarm
{
    LABEL   [menu_alarm_dev220];
    ITEMS
    {
        OnlineWindow_S_alarm_ai
    }
}
/*-------------------------------------------------------------------*/
MENU OnlineWindow_S_alarm_ai
{
    LABEL   "Analog Input"; 
    ITEMS
    {
        Page_alarm_sum_ai,
        Page_alarm_hi_hi_alm_ai,
        Page_alarm_hi_alm_ai,
        Page_alarm_lo_alm_ai,
        Page_alarm_lo_lo_alm_ai
    }
}

MENU Page_alarm_sum_ai
{
    LABEL   "Alarm Summary";    /* [menu_dialog_alarm_sum]; */
    ITEMS
    {
        aifb_current_state_alarm_sum
    }
}

MENU Page_alarm_hi_hi_alm_ai
{
    LABEL   [limit_hi_hi];
    ITEMS
    {
        aifb_hi_hi_alm_unacknowledged,
        aifb_hi_hi_alm_state,
        /* aifb_hi_hi_alm_time_stamp,   */
        aifb_hi_hi_alm_subcode,
        aifb_hi_hi_lim (READ_ONLY),
        aifb_hi_hi_alm_value
    }
}

MENU Page_alarm_hi_alm_ai
{
    LABEL   [limit_hi];
    ITEMS
    {
        aifb_hi_alm_unacknowledged,
        aifb_hi_alm_state,
        /* aifb_hi_alm_time_stamp,      */
        aifb_hi_alm_subcode,
        aifb_hi_lim (READ_ONLY),
        aifb_hi_alm_value
    }
}

MENU Page_alarm_lo_alm_ai
{
    LABEL   [limit_lo];
    ITEMS
    {
        aifb_lo_alm_unacknowledged,
        aifb_lo_alm_state,
        /* aifb_lo_alm_time_stamp,      */
        aifb_lo_alm_subcode,
        aifb_lo_lim (READ_ONLY),
        aifb_lo_alm_value
    }
}

MENU Page_alarm_lo_lo_alm_ai
{
    LABEL   [limit_lo_lo];
    ITEMS
    {
        aifb_lo_lo_alm_unacknowledged,
        aifb_lo_lo_alm_state,
        /* aifb_lo_lo_alm_time_stamp,   */
        aifb_lo_lo_alm_subcode,
        aifb_lo_lo_lim(READ_ONLY),
        aifb_lo_lo_alm_value
    }
}

/*-------------------------------------------------------------------*/
/*----------------- OnlineWindow_st_rev -----------------------------*/

MENU OnlineWindow_st_rev
{
    LABEL "ST_REV";
    ITEMS
    {
        phys_st_rev,
        trans1_st_rev,
        aifb_st_rev
    }
}

/*-------------------------------------------------------------------*/
/*----------------- OnlineWindow_M_alarm ----------------------------*/

MENU OnlineWindow_M_alarm
{
    LABEL   "Analog Input";
    ITEMS
    {
        Page_alarm_sum_ai
    }
}
/*-------------------------------------------------------------------*/
/*********************************************************************/
/*****  Menu  table  *************************************************/
/*********************************************************************/
/*****  Table: Specialist  *******************************************/
/*********************************************************************/

MENU Table_Main_Specialist
{
    LABEL   "CiDRA SONAR";
    ITEMS
    {
        Tab_s_info,
        Tab_s_tbs,
        Tab_s_fbs
    }
}
/*-------------------------------------------------------------------*/
/*---------------- Tab_s_info ---------------------------------------*/
MENU Tab_s_info
{
    LABEL   "Device Info";
    ITEMS
    {
        Tab_m_manuf_info,
        Tab_s_block_tag,
        Tab_s_get_info,
        Tab_serial_numbers,
        Tab_device_revisions, 
        Tab_s_certificates
    }
}
/*-------------------------------------------------------------------*/
MENU Tab_m_manuf_info
{
    LABEL   "Manufacturer Info";
    ITEMS
    {
        phys_device_man_id,
        phys_device_id
    }
}

MENU Tab_s_block_tag
{
    LABEL   "TAG";
    ITEMS
    {
        phys_tag_desc,
        trans1_tag_desc,
        aifb_tag_desc
    }
}

MENU Tab_s_get_info
{
    LABEL   [get_device_info];
    ITEMS
    {
        phys_descriptor,
        phys_message,
        phys_install_date
    }
}

MENU Tab_serial_numbers
{
    LABEL   "Serial Numbers";
    ITEMS
    {
        phys_device_ser_num(READ_ONLY),
    }
}

MENU Tab_device_revisions
{
    LABEL   "Device Revisions";
    ITEMS
    {
        phys_software_rev,
        phys_hardware_rev,
        phys_blk_profile,
        phys_blk_profile_rev,
        phys_blk_dd_reference,
        phys_blk_dd_rev
    }
}

MENU Tab_s_certificates
{
    LABEL   "Device Certification";
    ITEMS
    {
        phys_device_certification (READ_ONLY)
    }
}

/*-------------------------------------------------------------------*/
/*---------------- Tab_s_tbs ----------------------------------------*/
MENU Tab_s_tbs
{
    LABEL   "Transducers";
    ITEMS
    {
        Tab_s_SONAR_TB,
    }
}

/*------------------ Tab_s_sonar_tb ------------------------------------*/
MENU Tab_s_SONAR_TB
{
    LABEL   "SONAR TB";
    ITEMS
    {
        Tab_s_mode,
        Tab_s_control,
        Tab_s_device_info,
        Tab_s_pipe_information,
        Tab_s_fluid_properties,
        Tab_s_environment,
        Tab_s_display,
        Tab_s_system,
        Tab_s_system_dynamic,
        Tab_s_preamp,
        Tab_s_flow_algorithm,
        Tab_s_flow_algorithm_dynamic,
        Tab_s_flow_calibraion,
        Tab_s_sos_algorithm,
        Tab_s_sos_algorithm_dynamic,
        Tab_s_spl_acoustic_level,
        Tab_s_analog_section,
        Tab_s_input_units,
        Tab_s_flow_nr_filter,
        Tab_s_flow_damping_filter,
        Tab_s_flow_spike_filter,
        Tab_s_gvf_nr_filter,
        Tab_s_gvf_damping_filter,
        Tab_s_gvf_spike_filter,
        Tab_s_sensor,
        Tab_s_sensor_spacing,
        Tab_s_sensor_scale_factor,
        Tab_s_measured_values,
        Tab_s_flow_rate,
        Tab_s_gvf,
        Tab_s_sos,
        Tab_s_sensorhead_temperature,
        Tab_s_total_flow,
        Tab_s_acoustic_level,
        Tab_s_output_0,
        Tab_s_output_1,
        Tab_s_output_2,
        Tab_s_sensor_max_min,
        Tab_s_senosr_alpha,
        Tab_s_pressure_input,
        Tab_s_temperature_input,
        Tab_s_input_1,
        Tab_s_input_2,
        Tab_s_input_3,
        Tab_s_pa_slave_info
    }
}

MENU Tab_s_mode
{
    LABEL   "Mode";
    ITEMS
    {
        tb_target_mode,
        tb_actual_mode
    }
}

MENU Tab_s_control
{
    LABEL   "Control";
    ITEMS
    {
        tb_control_write_control,
        tb_control_reset_totalizer,
        tb_control_clear_alarm,
        tb_control_clear_data_history
    }
}

MENU Tab_s_device_info
{
    LABEL   "Device Info";
    ITEMS
    {
        tb_device_info_transmitter_sn,
        tb_device_info_model_number,
        tb_device_info_software_revision,
        tb_device_info_alchemy_software_revision,
        tb_device_info_sensorhead_sn,
        tb_device_info_preamp_software_revision,
        tb_device_info_preamp_serial_number
    }
}

MENU Tab_s_pipe_information
{
    LABEL   "Pipe Information";
    ITEMS
    {
        tb_pipe_info_pipe_diameter_input_mode,
        tb_pipe_info_pipe_diameter_units,
        tb_pipe_info_pipe_id,
        tb_pipe_info_pipe_od,
        tb_pipe_info_pipe_od_wall_units,
        tb_pipe_info_pipe_wall_thickness,
        tb_pipe_info_pipe_size,
        tb_pipe_info_pipe_schedule,
        tb_pipe_info_sos_pipe_wall_thickness_units,
        tb_pipe_info_sos_pipe_wall_thickness,
        tb_pipe_info_sos_pipe_modulus_selection,
        tb_pipe_info_sos_pipe_modulus
    }
}

MENU Tab_s_fluid_properties
{
    LABEL   "Fluid Properties";
    ITEMS
    {
        tb_fluid_properties_flow_viscosity,
        tb_fluid_properties_sos_gas_constant_selection,
        tb_fluid_properties_sos_specfic_gravity_selection,
        tb_fluid_properties_sos_liquid_sound_speed_selection,
        tb_fluid_properties_sos_gas_constant,
        tb_fluid_properties_sos_specific_gravity,
        tb_fluid_properties_sos_liquid_sound_speed,
        tb_fluid_properties_sos_polytropic_exponent,
        tb_fluid_properties_sos_liquid_density
    }
}

MENU Tab_s_environment
{
    LABEL   "Environment" ;
    ITEMS
    {
        tb_environment_sos_temperature_input_selection,
        tb_environment_sos_pressure_input_selection,
        tb_environment_sos_temperature_units,
        tb_environment_sos_pressure_units,
        tb_environment_sos_process_temperature,
        tb_environment_sos_process_pressure,
        tb_environment_altitude_units,
        tb_environment_altitude
    }
}

MENU Tab_s_display
{
    LABEL   "Display";
    ITEMS
    {
        tb_display_flow_volume_units,
        tb_display_flow_time_units,
        tb_display_flow_low_cutoff_pct,
        tb_display_flow_high_cutoff_pct,
        tb_display_flow_custom_base_volume_unit,
        tb_display_flow_custom_base_time_unit,
        tb_display_flow_custom_volume_unit_label,
        tb_display_flow_custom_time_unit_label,
        tb_display_flow_custom_volume_unit_multiplier,
        tb_display_flow_custom_time_unit_multiplier,
        tb_display_flow_quality_delta,
        tb_display_gvf_decimal_places,
        tb_display_sos_measurement_units,
        tb_display_sos_quality_delta
    }
}

MENU Tab_s_system
{
    LABEL   "System";
    ITEMS
    {
        tb_system_system_config_mode,
        tb_system_update_rate,
        tb_system_sensors_in_use,
        tb_system_transmitter_gain,
        tb_system_spl_threshold,
        tb_system_write_protect,
        tb_system_idle_timeout,
        tb_system_ethernet_idle_timeout,
        tb_system_out_of_range_mode
    }
}

MENU Tab_s_system_dynamic
{
    LABEL   "System Dynamic";
    ITEMS
    {
        tb_system_dynamic_spl_average,
        tb_system_dynamic_spl_std_dev
    }
}

MENU Tab_s_preamp
{
    LABEL   "Preamp";
    ITEMS
    {
        tb_preamp_gain,
        tb_preamp_auto_gain_mode,
        tb_preamp_charge_gain,
        tb_preamp_gain_0,
        tb_preamp_gain_1,
        tb_preamp_gain_2,
        tb_preamp_gain_3
    }
}

MENU Tab_s_flow_algorithm
{
    LABEL   "Flow Algorithm";
    ITEMS
    {
        tb_flow_algorithm_flow_sample_freq,
        tb_flow_algorithm_flow_channel_skew,
        tb_flow_algorithm_flow_freq_min,
        tb_flow_algorithm_flow_freq_max,
        tb_flow_algorithm_flow_rate_min,
        tb_flow_algorithm_flow_rate_max,
        tb_flow_algorithm_flow_min_quality,
        tb_flow_algorithm_flow_nyquist_high,
        tb_flow_algorithm_flow_nyquist_low,
        tb_flow_algorithm_flow_centroid_width,
        tb_flow_algorithm_flow_vel_search_limit_low,
        tb_flow_algorithm_flow_vel_search_limit_high,
        tb_flow_algorithm_flow_nyquist_initial_value,
        tb_flow_algorithm_flow_decimation,
        tb_flow_algorithm_flow_window_type,
        tb_flow_algorithm_flow_detrend,
        tb_flow_algorithm_flow_normalization,
        tb_flow_algorithm_flow_differencing,
        tb_flow_algorithm_flow_window_averages,
        tb_flow_algorithm_flow_direction,
        tb_flow_algorithm_flow_window_size_multiplier,
        tb_flow_algorithm_flow_peak_search_mode,
        tb_flow_algorithm_flow_operating_mode,
        tb_flow_algorithm_flow_quality_mode,
        tb_flow_algorithm_flow_bi_direction
    }
}

MENU Tab_s_flow_algorithm_dynamic
{
    LABEL   "Flow Algorithm Dynamic";
    ITEMS
    {
        tb_flow_algorithm_dynamic_flow_data_length,
        tb_flow_algorithm_dynamic_flow_window_size,
        tb_flow_algorithm_dynamic_flow_window_overlap,
        tb_flow_algorithm_dynamic_flow_window_averages
    }
}

MENU Tab_s_flow_calibration
{
    LABEL   "Flow Calibration";
    ITEMS
    {
        tb_flow_calibration_flow_cal_coeff_c0,
        tb_flow_calibration_flow_cal_coeff_c1,
        tb_flow_calibration_flow_cal_coeff_c2
    }
}

MENU Tab_s_sos_algorithm
{
    LABEL   "SOS Algorithm";
    ITEMS
    {
        tb_sos_algorithm_sos_sample_freq,
        tb_sos_algorithm_sos_freq_min,
        tb_sos_algorithm_sos_freq_max,
        tb_sos_algorithm_sos_min,
        tb_sos_algorithm_sos_max,
        tb_sos_algorithm_sos_min_quality,
        tb_sos_algorithm_sos_centroid_width,
        tb_sos_algorithm_sos_frequency_threshold,
        tb_sos_algorithm_sos_min_k,
        tb_sos_algorithm_sos_max_k,
        tb_sos_algorithm_sos_search_limit,
        tb_sos_algorithm_sos_lambda_diam,
        tb_sos_algorithm_sos_total_data,
        tb_sos_algorithm_sos_window_size,
        tb_sos_algorithm_sos_window_overlap,
        tb_sos_algorithm_sos_sub_array_size,
        tb_sos_algorithm_sos_normalization,
        tb_sos_algorithm_sos_differencing,
        tb_sos_algorithm_sos_operating_mode,
        tb_sos_algorithm_sos_selection_threshold,
        tb_sos_algorithm_sos_min_freq_points
    }
}

MENU Tab_s_sos_algorithm_dynamic
{
    LABEL   "SOS Algorithm Dynmaic";
    ITEMS
    {
        tb_sos_algorithm_dynamic_sos_valid_freq_pts_right,
        tb_sos_algorithm_dynamic_sos_valid_freq_pts_left
    }
}

MENU Tab_s_spl_acoustic_level
{
    LABEL   "SPL Acoustic Level";
    ITEMS
    {
        tb_spl_acoustic_level_spl_min_freq,
        tb_spl_acoustic_level_spl_max_freq,
        tb_spl_acoustic_level_al_min_freq,
        tb_spl_acoustic_level_al_max_freq,
        tb_spl_acoustic_level_al_fft_points
    }
}

MENU Tab_s_analog_section
{
    LABEL   "Analog Section";
    ITEMS
    {
        tb_analog_section_analog_sensor_input_units_1,
        tb_analog_section_analog_sensor_input_units_2,
        tb_analog_section_analog_sensor_input_scale_1,
        tb_analog_section_analog_sensor_input_scale_2,
        tb_analog_section_analog_sensor_input_offset_1,
        tb_analog_section_analog_sensor_input_offset_2,
        tb_analog_section_analog_sensor_1_1st_order_damping_filter_enable,
        tb_analog_section_analog_sensor_2_1st_order_damping_filter_enable,
        tb_analog_section_analog_sensor_1_damping_tau,
        tb_analog_section_analog_sensor_2_damping_tau
    }
}

MENU Tab_s_input_units
{
    LABEL   "Input Units";
    ITEMS
    {
        tb_input_units_pressure_input_units,
        tb_input_units_temperature_input_units,
        tb_input_units_input_1_units,
        tb_input_units_input_2_units,
        tb_input_units_input_3_units
    }
}

MENU Tab_s_flow_nr_filter
{
    LABEL   "Flow NR Filter";
    ITEMS
    {
        tb_flow_nr_filter_enable,
        tb_flow_nr_filter_magnitude_selection
    }
}

MENU Tab_s_flow_damping_filter
{
    LABEL   "Flow Damping Filter";
    ITEMS
    {
        tb_flow_damping_filter_flow_1st_order_damping_filter_enable,
        tb_flow_damping_filter_flow_damping_tau
    }
}

MENU Tab_s_flow_spike_filter
{
    LABEL   "Flow Spike Filter";
    ITEMS
    {
        tb_flow_spike_filter_enable,
        tb_flow_spike_filter_no_flow_length,
        tb_flow_spike_filter_length,
        tb_flow_spike_filter_up_count,
        tb_flow_spike_filter_down_count,
        tb_flow_spike_filter_percentage,
        tb_flow_spike_filter_pct_window_len
    }
}

MENU Tab_s_gvf_nr_filter
{
    LABEL   "GVF NR Filter";
    ITEMS
    {
        tb_gvf_nr_filter_enable,
        tb_gvf_nr_filter_magnitude_selection
    }
}

MENU Tab_s_gvf_damping_filter
{
    LABEL   "GVF Damping Filter";
    ITEMS
    {
        tb_gvf_damping_filter_enable,
        tb_gvf_damping_filter_tau
    }
}

MENU Tab_s_gvf_spike_filter
{
    LABEL   "GVF Spike Filter";
    ITEMS
    {
        tb_gvf_spike_filter_enable,
        tb_gvf_spike_filter_no_gvf_length,
        tb_gvf_spike_filter_length,
        tb_gvf_spike_filter_up_count,
        tb_gvf_spike_filter_down_count,
        tb_gvf_spike_filter_percentage,
        tb_gvf_spike_filter_filt_pct_window_len
    }
}

MENU Tab_s_sensor
{
    LABEL   "Sensor";
    ITEMS
    {
        tb_sensor_sensorhead_serial_number,
        tb_sensor_threshold_max,
        tb_sensor_threshold_min,
        tb_sensor_band_temp_rating,
        tb_sensor_band_type,
        tb_sensor_band_active_area,
        tb_sensor_scale_temp_source,
        tb_sensor_scale_comp_temperature,
        tb_sensor_scale_temp_factor
    }
}

MENU Tab_s_sensor_spacing
{
    LABEL   "Sensor Spacing";
    ITEMS
    {
        tb_sensor_spacing_sensor_1_location,
        tb_sensor_spacing_1_2,
        tb_sensor_spacing_1_3,
        tb_sensor_spacing_1_4,
        tb_sensor_spacing_1_5,
        tb_sensor_spacing_1_6,
        tb_sensor_spacing_1_7,
        tb_sensor_spacing_1_8
    }
}

MENU Tab_s_sensor_scale_factor
{
    LABEL   "Sensor Scale Factor";
    ITEMS
    {
        tb_sensor_scale_factor_1,
        tb_sensor_scale_factor_2,
        tb_sensor_scale_factor_3,
        tb_sensor_scale_factor_4,
        tb_sensor_scale_factor_5,
        tb_sensor_scale_factor_6,
        tb_sensor_scale_factor_7,
        tb_sensor_scale_factor_8
    }
}

MENU Tab_s_measured_values
{
    LABEL   "Measured Values";
    ITEMS
    {
        tb_measured_values_flow_quality,
        tb_measured_values_flow_rate_unfiltered,
        tb_measured_values_pressure,
        tb_measured_values_temperature,
        tb_measured_values_sos_quality,
        tb_measured_values_sos_unfiltered,
        tb_measured_values_sos_flow_rate,
        tb_measured_values_sos_flow_qual,
        tb_measured_values_tlf,
        tb_measured_values_total_tlf,
        tb_measured_values_tlf_unfiltered,
        tb_measured_values_analog_4_20ma_input_1,
        tb_measured_values_analog_4_20ma_input_2,
        tb_measured_values_total_flow_fraction,
        tb_measured_values_total_tlf_fraction,
        tb_measured_values_total_flow_carry,
        tb_measured_values_total_tlf_carry,
        tb_measured_values_system_status
    }
}

MENU Tab_s_flow_rate
{
    LABEL   "Flow Rate";
    ITEMS
    {
        tb_flow_rate_value,
        tb_flow_rate_status
    }
}

MENU Tab_s_gvf
{
    LABEL   "GVF";
    ITEMS
    {
        tb_gvf_value,
        tb_gvf_status
    }
}

MENU Tab_s_sos
{
    LABEL   "SOS";
    ITEMS
    {
        tb_sos_value,
        tb_sos_status
    }
}

MENU Tab_s_sensorhead_temperature
{
    LABEL   "Sensorhead Temperature";
    ITEMS
    {
        tb_sensorhead_temperature_value,
        tb_sensorhead_temperature_status
    }
}

MENU Tab_s_total_flow
{
    LABEL   "Total Flow";
    ITEMS
    {
        tb_total_flow_value,
        tb_total_flow_status
    }
}

MENU Tab_s_acoustic_level
{
    LABEL   "Acoustic Level";
    ITEMS
    {
        tb_acoustic_level_value,
        tb_acoustic_level_status
    }
}

MENU Tab_s_output_0
{
    LABEL   "Output 0";
    ITEMS
    {
        tb_output_0_value,
        tb_output_0_status
    }
}

MENU Tab_s_output_1
{
    LABEL   "Output 1";
    ITEMS
    {
        tb_output_1_value,
        tb_output_1_status
    }
}

MENU Tab_s_output_2
{
    LABEL   "Output 2";
    ITEMS
    {
        tb_output_2_value,
        tb_output_2_status
    }
}

MENU Tab_s_sensor_max_min
{
    LABEL   "Sensor Max Min";
    ITEMS
    {
        tb_sensor_max_min_sensor_1_max,
        tb_sensor_max_min_sensor_2_max,
        tb_sensor_max_min_sensor_3_max,
        tb_sensor_max_min_sensor_4_max,
        tb_sensor_max_min_sensor_5_max,
        tb_sensor_max_min_sensor_6_max,
        tb_sensor_max_min_sensor_7_max,
        tb_sensor_max_min_sensor_8_max,
        tb_sensor_max_min_sensor_1_min,
        tb_sensor_max_min_sensor_2_min,
        tb_sensor_max_min_sensor_3_min,
        tb_sensor_max_min_sensor_4_min,
        tb_sensor_max_min_sensor_5_min,
        tb_sensor_max_min_sensor_6_min,
        tb_sensor_max_min_sensor_7_min,
        tb_sensor_max_min_sensor_8_min
    }
}

MENU Tab_s_sensor_alpha
{
    LABEL   "Sensor Alpha";
    ITEMS
    {
        tb_sensor_alpha_1,
        tb_sensor_alpha_2,
        tb_sensor_alpha_3,
        tb_sensor_alpha_4,
        tb_sensor_alpha_5,
        tb_sensor_alpha_6,
        tb_sensor_alpha_7,
        tb_sensor_alpha_8
    }
}

MENU Tab_s_pressure_input
{
    LABEL   "Pressure Input";
    ITEMS
    {
        tb_pressure_input_value,
        tb_pressure_input_status
    }
}

MENU Tab_s_temperature_input
{
    LABEL   "Temperature Input";
    ITEMS
    {
        tb_temperature_input_value,
        tb_temperature_input_status
    }
}

MENU Tab_s_input_1
{
    LABEL   "Input 1";
    ITEMS
    {
        tb_input_1_value,
        tb_input_1_status
    }
}

MENU Tab_s_input_2
{
    LABEL   "Input 2";
    ITEMS
    {
        tb_input_2_value,
        tb_input_2_status
    }
}

MENU Tab_s_input_3
{
    LABEL   "Input 3";
    ITEMS          
    {
        tb_input_3_value,
        tb_input_3_status
    }
}

MENU Tab_s_pa_slave_info
{
    LABEL   "PA Slave Info";
    ITEMS          
    {
        tb_pa_slave_info_firmware_revision,
        tb_pa_slave_info_node_address,
        tb_pa_slave_info_block_mode_phy,
        tb_pa_slave_info_block_mode_tb,
        tb_pa_slave_info_slave_mode,
        tb_pa_slave_info_slave_ident_number
    }
}


/*-------------------------------------------------------------------*/
/*---------------- Tab_s_fbs -----------------------------------------*/
MENU Tab_s_fbs
{
    LABEL   "Function Blocks";
    ITEMS
    {
        Tab_s_aifb,
        Tab_s_aifb_2,
        Tab_s_aifb_3,
        Tab_s_aifb_4,
        Tab_s_aifb_5,
        Tab_s_aifb_6,
        Tab_s_aifb_7,
        Tab_s_aifb_8,
        Tab_s_aifb_9,
        Tab_s_aofb,
        Tab_s_aofb_2,
        Tab_s_aofb_3,
        Tab_s_aofb_4,
        Tab_s_aofb_5,
    }
}

/*-------------------------- Tab_s_aifb --------------------------*/
MENU Tab_s_aifb
{
    LABEL   "AI Function Block";
    ITEMS
    {
       Tab_s_target_mode_ai,
       Tab_s_actual_mode_ai,
       Tab_s_channel_ai,
       Tab_s_scale_pv_ai,
       Tab_s_scale_out_ai,
       Tab_s_out
    }
}

/*-------------------------------------------------------------------*/
MENU Tab_s_target_mode_ai
{
    LABEL   "AI Target Mode";
    ITEMS
    {
        aifb_target_mode
    }
}

MENU Tab_s_actual_mode_ai
{
    LABEL   "AI Actual Mode";
    ITEMS
    {
        aifb_actual_mode
    }
}

MENU Tab_s_channel_ai
{
    LABEL   "AI Channel";
    ITEMS
    {
        aifb_channel
    }
}

MENU Tab_s_scale_pv_ai
{
    LABEL   "PV Scale";
    ITEMS
    {
        aifb_pv_lower_range_value,
        aifb_pv_upper_range_value
    }
}

MENU Tab_s_scale_out_ai
{
    LABEL   "Out Scale";
    ITEMS
    {
        aifb_out_lower_range_value,
        aifb_out_upper_range_value,
        aifb_out_unit,
        aifb_out_decimal_point,
    }
}

MENU Tab_s_out
{
    LABEL  "Out";
    ITEMS
    {
      aifb_out_value,
      aifb_out_status
    }
}

/*-------------------------- Tab_s_aifb_2 --------------------------*/
MENU Tab_s_aifb_2
{
    LABEL   "AI Function Block 2";
    ITEMS
    {
       Tab_s_target_mode_ai_2,
       Tab_s_actual_mode_ai_2,
       Tab_s_channel_ai_2,
       Tab_s_scale_pv_ai_2,
       Tab_s_scale_out_ai_2,
       Tab_s_out_ai_2
    }
}

/*-------------------------------------------------------------------*/
MENU Tab_s_target_mode_ai_2
{
    LABEL   "AI Target Mode";
    ITEMS
    {
        aifb_2_target_mode
    }
}

MENU Tab_s_actual_mode_ai_2
{
    LABEL   "AI Actual Mode";
    ITEMS
    {
        aifb_2_actual_mode
    }
}

MENU Tab_s_channel_ai_2
{
    LABEL   "AI Channel";
    ITEMS
    {
        aifb_2_channel
    }
}

MENU Tab_s_scale_pv_ai_2
{
    LABEL   "PV Scale";
    ITEMS
    {
        aifb_2_pv_lower_range_value,
        aifb_2_pv_upper_range_value
    }
}

MENU Tab_s_scale_out_ai_2
{
    LABEL   "Out Scale";
    ITEMS
    {
        aifb_2_out_lower_range_value,
        aifb_2_out_upper_range_value,
        aifb_2_out_unit,
        aifb_2_out_decimal_point,
    }
}

MENU Tab_s_out_ai_2
{
    LABEL  "Out";
    ITEMS
    {
      aifb_2_out_value,
      aifb_2_out_status
    }
}

/*-------------------------- Tab_s_aifb_3 --------------------------*/
MENU Tab_s_aifb_3
{
    LABEL   "AI Function Block 3";
    ITEMS
    {
       Tab_s_target_mode_ai_3,
       Tab_s_actual_mode_ai_3,
       Tab_s_channel_ai_3,
       Tab_s_scale_pv_ai_3,
       Tab_s_scale_out_ai_3,
       Tab_s_out_ai_3
    }
}

/*-------------------------------------------------------------------*/
MENU Tab_s_target_mode_ai_3
{
    LABEL   "AI Target Mode";
    ITEMS
    {
        aifb_3_target_mode
    }
}

MENU Tab_s_actual_mode_ai_3
{
    LABEL   "AI Actual Mode";
    ITEMS
    {
        aifb_3_actual_mode
    }
}

MENU Tab_s_channel_ai_3
{
    LABEL   "AI Channel";
    ITEMS
    {
        aifb_3_channel
    }
}

MENU Tab_s_scale_pv_ai_3
{
    LABEL   "PV Scale";
    ITEMS
    {
        aifb_3_pv_lower_range_value,
        aifb_3_pv_upper_range_value
    }
}

MENU Tab_s_scale_out_ai_3
{
    LABEL   "Out Scale";
    ITEMS
    {
        aifb_3_out_lower_range_value,
        aifb_3_out_upper_range_value,
        aifb_3_out_unit,
        aifb_3_out_decimal_point,
    }
}

MENU Tab_s_out_ai_3
{
    LABEL  "Out";
    ITEMS
    {
      aifb_3_out_value,
      aifb_3_out_status
    }
}

/*-------------------------- Tab_s_aifb_4 --------------------------*/
MENU Tab_s_aifb_4
{
    LABEL   "AI Function Block 4";
    ITEMS
    {
       Tab_s_target_mode_ai_4,
       Tab_s_actual_mode_ai_4,
       Tab_s_channel_ai_4,
       Tab_s_scale_pv_ai_4,
       Tab_s_scale_out_ai_4,
       Tab_s_out_ai_4
    }
}

/*-------------------------------------------------------------------*/
MENU Tab_s_target_mode_ai_4
{
    LABEL   "AI Target Mode";
    ITEMS
    {
        aifb_4_target_mode
    }
}

MENU Tab_s_actual_mode_ai_4
{
    LABEL   "AI Actual Mode";
    ITEMS
    {
        aifb_4_actual_mode
    }
}

MENU Tab_s_channel_ai_4
{
    LABEL   "AI Channel";
    ITEMS
    {
        aifb_4_channel
    }
}

MENU Tab_s_scale_pv_ai_4
{
    LABEL   "PV Scale";
    ITEMS
    {
        aifb_4_pv_lower_range_value,
        aifb_4_pv_upper_range_value
    }
}

MENU Tab_s_scale_out_ai_4
{
    LABEL   "Out Scale";
    ITEMS
    {
        aifb_4_out_lower_range_value,
        aifb_4_out_upper_range_value,
        aifb_4_out_unit,
        aifb_4_out_decimal_point,
    }
}

MENU Tab_s_out_ai_4
{
    LABEL  "Out";
    ITEMS
    {
      aifb_4_out_value,
      aifb_4_out_status
    }
}

/*-------------------------- Tab_s_aifb_5 --------------------------*/
MENU Tab_s_aifb_5
{
    LABEL   "AI Function Block 5";
    ITEMS
    {
       Tab_s_target_mode_ai_5,
       Tab_s_actual_mode_ai_5,
       Tab_s_channel_ai_5,
       Tab_s_scale_pv_ai_5,
       Tab_s_scale_out_ai_5,
       Tab_s_out_ai_5
    }
}

/*-------------------------------------------------------------------*/
MENU Tab_s_target_mode_ai_5
{
    LABEL   "AI Target Mode";
    ITEMS
    {
        aifb_5_target_mode
    }
}

MENU Tab_s_actual_mode_ai_5
{
    LABEL   "AI Actual Mode";
    ITEMS
    {
        aifb_5_actual_mode
    }
}

MENU Tab_s_channel_ai_5
{
    LABEL   "AI Channel";
    ITEMS
    {
        aifb_5_channel
    }
}

MENU Tab_s_scale_pv_ai_5
{
    LABEL   "PV Scale";
    ITEMS
    {
        aifb_5_pv_lower_range_value,
        aifb_5_pv_upper_range_value
    }
}

MENU Tab_s_scale_out_ai_5
{
    LABEL   "Out Scale";
    ITEMS
    {
        aifb_5_out_lower_range_value,
        aifb_5_out_upper_range_value,
        aifb_5_out_unit,
        aifb_5_out_decimal_point,
    }
}

MENU Tab_s_out_ai_5
{
    LABEL  "Out";
    ITEMS
    {
      aifb_5_out_value,
      aifb_5_out_status
    }
}

/*-------------------------- Tab_s_aifb_6 --------------------------*/
MENU Tab_s_aifb_6
{
    LABEL   "AI Function Block 6";
    ITEMS
    {
       Tab_s_target_mode_ai_6,
       Tab_s_actual_mode_ai_6,
       Tab_s_channel_ai_6,
       Tab_s_scale_pv_ai_6,
       Tab_s_scale_out_ai_6,
       Tab_s_out_ai_6
    }
}

/*-------------------------------------------------------------------*/
MENU Tab_s_target_mode_ai_6
{
    LABEL   "AI Target Mode";
    ITEMS
    {
        aifb_6_target_mode
    }
}

MENU Tab_s_actual_mode_ai_6
{
    LABEL   "AI Actual Mode";
    ITEMS
    {
        aifb_6_actual_mode
    }
}

MENU Tab_s_channel_ai_6
{
    LABEL   "AI Channel";
    ITEMS
    {
        aifb_6_channel
    }
}

MENU Tab_s_scale_pv_ai_6
{
    LABEL   "PV Scale";
    ITEMS
    {
        aifb_6_pv_lower_range_value,
        aifb_6_pv_upper_range_value
    }
}

MENU Tab_s_scale_out_ai_6
{
    LABEL   "Out Scale";
    ITEMS
    {
        aifb_6_out_lower_range_value,
        aifb_6_out_upper_range_value,
        aifb_6_out_unit,
        aifb_6_out_decimal_point,
    }
}

MENU Tab_s_out_ai_6
{
    LABEL  "Out";
    ITEMS
    {
      aifb_6_out_value,
      aifb_6_out_status
    }
}

/*-------------------------- Tab_s_aifb_7 --------------------------*/
MENU Tab_s_aifb_7
{
    LABEL   "AI Function Block 7";
    ITEMS
    {
       Tab_s_target_mode_ai_7,
       Tab_s_actual_mode_ai_7,
       Tab_s_channel_ai_7,
       Tab_s_scale_pv_ai_7,
       Tab_s_scale_out_ai_7,
       Tab_s_out_ai_7
    }
}

/*-------------------------------------------------------------------*/
MENU Tab_s_target_mode_ai_7
{
    LABEL   "AI Target Mode";
    ITEMS
    {
        aifb_7_target_mode
    }
}

MENU Tab_s_actual_mode_ai_7
{
    LABEL   "AI Actual Mode";
    ITEMS
    {
        aifb_7_actual_mode
    }
}

MENU Tab_s_channel_ai_7
{
    LABEL   "AI Channel";
    ITEMS
    {
        aifb_7_channel
    }
}

MENU Tab_s_scale_pv_ai_7
{
    LABEL   "PV Scale";
    ITEMS
    {
        aifb_7_pv_lower_range_value,
        aifb_7_pv_upper_range_value
    }
}

MENU Tab_s_scale_out_ai_7
{
    LABEL   "Out Scale";
    ITEMS
    {
        aifb_7_out_lower_range_value,
        aifb_7_out_upper_range_value,
        aifb_7_out_unit,
        aifb_7_out_decimal_point,
    }
}

MENU Tab_s_out_ai_7
{
    LABEL  "Out";
    ITEMS
    {
      aifb_7_out_value,
      aifb_7_out_status
    }
}

/*-------------------------- Tab_s_aifb_8 --------------------------*/
MENU Tab_s_aifb_8
{
    LABEL   "AI Function Block 8";
    ITEMS
    {
       Tab_s_target_mode_ai_8,
       Tab_s_actual_mode_ai_8,
       Tab_s_channel_ai_8,
       Tab_s_scale_pv_ai_8,
       Tab_s_scale_out_ai_8,
       Tab_s_out_ai_8
    }
}

/*-------------------------------------------------------------------*/
MENU Tab_s_target_mode_ai_8
{
    LABEL   "AI Target Mode";
    ITEMS
    {
        aifb_8_target_mode
    }
}

MENU Tab_s_actual_mode_ai_8
{
    LABEL   "AI Actual Mode";
    ITEMS
    {
        aifb_8_actual_mode
    }
}

MENU Tab_s_channel_ai_8
{
    LABEL   "AI Channel";
    ITEMS
    {
        aifb_8_channel
    }
}

MENU Tab_s_scale_pv_ai_8
{
    LABEL   "PV Scale";
    ITEMS
    {
        aifb_8_pv_lower_range_value,
        aifb_8_pv_upper_range_value
    }
}

MENU Tab_s_scale_out_ai_8
{
    LABEL   "Out Scale";
    ITEMS
    {
        aifb_8_out_lower_range_value,
        aifb_8_out_upper_range_value,
        aifb_8_out_unit,
        aifb_8_out_decimal_point,
    }
}

MENU Tab_s_out_ai_8
{
    LABEL  "Out";
    ITEMS
    {
      aifb_8_out_value,
      aifb_8_out_status
    }
}

/*-------------------------- Tab_s_aifb_9 --------------------------*/
MENU Tab_s_aifb_9
{
    LABEL   "AI Function Block 9";
    ITEMS
    {
       Tab_s_target_mode_ai_9,
       Tab_s_actual_mode_ai_9,
       Tab_s_channel_ai_9,
       Tab_s_scale_pv_ai_9,
       Tab_s_scale_out_ai_9,
       Tab_s_out_ai_9
    }
}

/*-------------------------------------------------------------------*/
MENU Tab_s_target_mode_ai_9
{
    LABEL   "AI Target Mode";
    ITEMS
    {
        aifb_9_target_mode
    }
}

MENU Tab_s_actual_mode_ai_9
{
    LABEL   "AI Actual Mode";
    ITEMS
    {
        aifb_9_actual_mode
    }
}

MENU Tab_s_channel_ai_9
{
    LABEL   "AI Channel";
    ITEMS
    {
        aifb_9_channel
    }
}

MENU Tab_s_scale_pv_ai_9
{
    LABEL   "PV Scale";
    ITEMS
    {
        aifb_9_pv_lower_range_value,
        aifb_9_pv_upper_range_value
    }
}

MENU Tab_s_scale_out_ai_9
{
    LABEL   "Out Scale";
    ITEMS
    {
        aifb_9_out_lower_range_value,
        aifb_9_out_upper_range_value,
        aifb_9_out_unit,
        aifb_9_out_decimal_point,
    }
}

MENU Tab_s_out_ai_9
{
    LABEL  "Out";
    ITEMS
    {
      aifb_9_out_value,
      aifb_9_out_status
    }
}

/*------------------------ Tab_s_aofb -------------------------------*/
MENU Tab_s_aofb
{
    LABEL "AO Function Block";
    ITEMS
    {
        Tab_target_mode_ao,
        Tab_actual_mode_ao,
        Tab_in_channel_ao,
        Tab_out_channel_ao,
        Tab_process_value_scale_ao,
        Tab_output_scale_ao,
        Tab_out_ao
    }
}

MENU Tab_target_mode_ao
{
    LABEL "AO Target Mode";
    ITEMS
    {
        aofb_target_mode
    }
}

MENU Tab_actual_mode_ao
{
    LABEL "AO Actual Mode";
    ITEMS
    {
        aofb_actual_mode
    }
}

MENU Tab_in_channel_ao
{
    LABEL "AO IN Channel";
    ITEMS
    {
        aofb_in_channel
    }
}


MENU Tab_out_channel_ao
{
    LABEL "AO Out Channel";
    ITEMS
    {
        aofb_out_channel
    }
}

MENU Tab_process_value_scale_ao
{
    LABEL "AO PV Scale";
    ITEMS
    {
        aofb_pv_upper_range_value,
        aofb_pv_lower_range_value,
        aofb_pv_unit,
        aofb_pv_decimal_point
    }
}

MENU Tab_output_scale_ao
{
    LABEL "AO OUT Scale";
    ITEMS
    {
        aofb_out_upper_range_value, 
        aofb_out_lower_range_value, 
        aofb_out_unit, 
        aofb_out_decimal_point 
    }
}

MENU Tab_out_ao
{
    LABEL "AO Out";
    ITEMS
    {
        aofb_out_value,
        aofb_out_status
    }
}

/*------------------------ Tab_s_aofb_2 -------------------------------*/
MENU Tab_s_aofb_2
{
    LABEL "AO Function Block 2";
    ITEMS
    {
        Tab_target_mode_ao_2,
        Tab_actual_mode_ao_2,
        Tab_in_channel_ao_2,
        Tab_out_channel_ao_2,
        Tab_process_value_scale_ao_2,
        Tab_output_scale_ao_2,
        Tab_out_ao_2
    }
}

MENU Tab_target_mode_ao_2
{
    LABEL "AO Target Mode";
    ITEMS
    {
        aofb_2_target_mode
    }
}

MENU Tab_actual_mode_ao_2
{
    LABEL "AO Actual Mode";
    ITEMS
    {
        aofb_2_actual_mode
    }
}

MENU Tab_in_channel_ao_2
{
    LABEL "AO IN Channel";
    ITEMS
    {
        aofb_2_in_channel
    }
}


MENU Tab_out_channel_ao_2
{
    LABEL "AO Out Channel";
    ITEMS
    {
        aofb_2_out_channel
    }
}

MENU Tab_process_value_scale_ao_2
{
    LABEL "AO PV Scale";
    ITEMS
    {
        aofb_2_pv_upper_range_value,
        aofb_2_pv_lower_range_value,
        aofb_2_pv_unit,
        aofb_2_pv_decimal_point
    }
}

MENU Tab_output_scale_ao_2
{
    LABEL "AO OUT Scale";
    ITEMS
    {
        aofb_2_out_upper_range_value, 
        aofb_2_out_lower_range_value, 
        aofb_2_out_unit, 
        aofb_2_out_decimal_point 
    }
}

MENU Tab_out_ao_2
{
    LABEL "AO Out";
    ITEMS
    {
        aofb_2_out_value,
        aofb_2_out_status
    }
}

/*------------------------ Tab_s_aofb_3 -------------------------------*/
MENU Tab_s_aofb_3
{
    LABEL "AO Function Block 3";
    ITEMS
    {
        Tab_target_mode_ao_3,
        Tab_actual_mode_ao_3,
        Tab_in_channel_ao_3,
        Tab_out_channel_ao_3,
        Tab_process_value_scale_ao_3,
        Tab_output_scale_ao_3,
        Tab_out_ao_3
    }
}

MENU Tab_target_mode_ao_3
{
    LABEL "AO Target Mode";
    ITEMS
    {
        aofb_3_target_mode
    }
}

MENU Tab_actual_mode_ao_3
{
    LABEL "AO Actual Mode";
    ITEMS
    {
        aofb_3_actual_mode
    }
}

MENU Tab_in_channel_ao_3
{
    LABEL "AO IN Channel";
    ITEMS
    {
        aofb_3_in_channel
    }
}


MENU Tab_out_channel_ao_3
{
    LABEL "AO Out Channel";
    ITEMS
    {
        aofb_3_out_channel
    }
}

MENU Tab_process_value_scale_ao_3
{
    LABEL "AO PV Scale";
    ITEMS
    {
        aofb_3_pv_upper_range_value,
        aofb_3_pv_lower_range_value,
        aofb_3_pv_unit,
        aofb_3_pv_decimal_point
    }
}

MENU Tab_output_scale_ao_3
{
    LABEL "AO OUT Scale";
    ITEMS
    {
        aofb_3_out_upper_range_value, 
        aofb_3_out_lower_range_value, 
        aofb_3_out_unit, 
        aofb_3_out_decimal_point 
    }
}

MENU Tab_out_ao_3
{
    LABEL "AO Out";
    ITEMS
    {
        aofb_3_out_value,
        aofb_3_out_status
    }
}

/*------------------------ Tab_s_aofb_4 -------------------------------*/
MENU Tab_s_aofb_4
{
    LABEL "AO Function Block 4";
    ITEMS
    {
        Tab_target_mode_ao_4,
        Tab_actual_mode_ao_4,
        Tab_in_channel_ao_4,
        Tab_out_channel_ao_4,
        Tab_process_value_scale_ao_4,
        Tab_output_scale_ao_4,
        Tab_out_ao_4
    }
}

MENU Tab_target_mode_ao_4
{
    LABEL "AO Target Mode";
    ITEMS
    {
        aofb_4_target_mode
    }
}

MENU Tab_actual_mode_ao_4
{
    LABEL "AO Actual Mode";
    ITEMS
    {
        aofb_4_actual_mode
    }
}

MENU Tab_in_channel_ao_4
{
    LABEL "AO IN Channel";
    ITEMS
    {
        aofb_4_in_channel
    }
}


MENU Tab_out_channel_ao_4
{
    LABEL "AO Out Channel";
    ITEMS
    {
        aofb_4_out_channel
    }
}

MENU Tab_process_value_scale_ao_4
{
    LABEL "AO PV Scale";
    ITEMS
    {
        aofb_4_pv_upper_range_value,
        aofb_4_pv_lower_range_value,
        aofb_4_pv_unit,
        aofb_4_pv_decimal_point
    }
}

MENU Tab_output_scale_ao_4
{
    LABEL "AO OUT Scale";
    ITEMS
    {
        aofb_4_out_upper_range_value, 
        aofb_4_out_lower_range_value, 
        aofb_4_out_unit, 
        aofb_4_out_decimal_point 
    }
}

MENU Tab_out_ao_4
{
    LABEL "AO Out";
    ITEMS
    {
        aofb_4_out_value,
        aofb_4_out_status
    }
}

/*------------------------ Tab_s_aofb_5 -------------------------------*/
MENU Tab_s_aofb_5
{
    LABEL "AO Function Block 5";
    ITEMS
    {
        Tab_target_mode_ao_5,
        Tab_actual_mode_ao_5,
        Tab_in_channel_ao_5,
        Tab_out_channel_ao_5,
        Tab_process_value_scale_ao_5,
        Tab_output_scale_ao_5,
        Tab_out_ao_5
    }
}

MENU Tab_target_mode_ao_5
{
    LABEL "AO Target Mode";
    ITEMS
    {
        aofb_5_target_mode
    }
}

MENU Tab_actual_mode_ao_5
{
    LABEL "AO Actual Mode";
    ITEMS
    {
        aofb_5_actual_mode
    }
}

MENU Tab_in_channel_ao_5
{
    LABEL "AO IN Channel";
    ITEMS
    {
        aofb_5_in_channel
    }
}


MENU Tab_out_channel_ao_5
{
    LABEL "AO Out Channel";
    ITEMS
    {
        aofb_5_out_channel
    }
}

MENU Tab_process_value_scale_ao_5
{
    LABEL "AO PV Scale";
    ITEMS
    {
        aofb_5_pv_upper_range_value,
        aofb_5_pv_lower_range_value,
        aofb_5_pv_unit,
        aofb_5_pv_decimal_point
    }
}

MENU Tab_output_scale_ao_5
{
    LABEL "AO OUT Scale";
    ITEMS
    {
        aofb_5_out_upper_range_value, 
        aofb_5_out_lower_range_value, 
        aofb_5_out_unit, 
        aofb_5_out_decimal_point 
    }
}

MENU Tab_out_ao_5
{
    LABEL "AO Out";
    ITEMS
    {
        aofb_5_out_value,
        aofb_5_out_status
    }
}

/******************************************************************************/
/*****  Specific Method *******************************************************/
/******************************************************************************/
METHOD std_NodeAddress
{
    LABEL       [menu_Device_NodeAddress];
    DEFINITION
    {
    }
}

/*-------------------------------------------------------------------*/
METHOD method_write_target_mode_ai
{
    LABEL   "Write";
    DEFINITION
    {
        WriteCommand(write_aifb_target_mode);
        ReadCommand(read_aifb_target_mode);
    }
}
/*-------------------------------------------------------------------*/
METHOD method_write_channel_ai                  
{
    LABEL   "Write";
    DEFINITION
    {
        WriteCommand(write_aifb_channel);
        ReadCommand (read_aifb_channel);
        /* You can also set the correspondent units here */
    }
}
/*-------------------------------------------------------------------*/
METHOD method_write_scale_pv_ai
{
    LABEL   "Write";
    DEFINITION
    {
        WriteCommand(write_aifb_pv);
        ReadCommand(read_aifb_pv);
    }
}
/*-------------------------------------------------------------------*/
METHOD method_write_scale_out_ai
{
    LABEL   "Write";
    DEFINITION
    {
        WriteCommand(write_aifb_out_scale);
        ReadCommand(read_aifb_out_scale);
    }
}


/******************************************************************************/
/*****  upload/download Commands        ***************************************/
/******************************************************************************/
MENU download_variables
{
    LABEL   [menu_load_to_PC];
    ITEMS
    {
    
/*------------- PHYSICAL BLOCK  ---------------------------------------------*/
        
        phys_descriptor,
        phys_message,
        phys_install_date,
        phys_device_certification,
        phys_tag_desc,
        phys_device_ser_num,
        phys_software_rev,
        phys_hardware_rev,
        phys_blk_profile,
        phys_blk_profile_rev,
        phys_blk_dd_reference,
        phys_blk_dd_rev,
        phys_device_man_id,
        phys_device_id,

/*------------- TRANDSDUCER BLOCK 1: AITB   ------------------------------*/

        tb_target_mode,
        tb_actual_mode,
        tb_control_write_control,
        tb_control_reset_totalizer,
        tb_control_clear_alarm,
        tb_control_clear_data_history,
        tb_device_info_transmitter_sn,
        tb_device_info_model_number,
        tb_device_info_software_revision,
        tb_device_info_alchemy_software_revision,
        tb_device_info_sensorhead_sn,
        tb_device_info_preamp_software_revision,
        tb_device_info_preamp_serial_number,
        tb_pipe_info_pipe_diameter_input_mode,
        tb_pipe_info_pipe_diameter_units,
        tb_pipe_info_pipe_id,
        tb_pipe_info_pipe_od,
        tb_pipe_info_pipe_od_wall_units,
        tb_pipe_info_pipe_wall_thickness,
        tb_pipe_info_pipe_size,
        tb_pipe_info_pipe_schedule,
        tb_pipe_info_sos_pipe_wall_thickness_units,
        tb_pipe_info_sos_pipe_wall_thickness,
        tb_pipe_info_sos_pipe_modulus_selection,
        tb_pipe_info_sos_pipe_modulus,
        tb_fluid_properties_flow_viscosity,
        tb_fluid_properties_sos_gas_constant_selection,
        tb_fluid_properties_sos_specfic_gravity_selection,
        tb_fluid_properties_sos_liquid_sound_speed_selection,
        tb_fluid_properties_sos_gas_constant,
        tb_fluid_properties_sos_specific_gravity,
        tb_fluid_properties_sos_liquid_sound_speed,
        tb_fluid_properties_sos_polytropic_exponent,
        tb_fluid_properties_sos_liquid_density,
        tb_environment_sos_temperature_input_selection,
        tb_environment_sos_pressure_input_selection,
        tb_environment_sos_temperature_units,
        tb_environment_sos_pressure_units,
        tb_environment_sos_process_temperature,
        tb_environment_sos_process_pressure,
        tb_environment_altitude_units,
        tb_environment_altitude,
        tb_display_flow_volume_units,
        tb_display_flow_time_units,
        tb_display_flow_low_cutoff_pct,
        tb_display_flow_high_cutoff_pct,
        tb_display_flow_custom_base_volume_unit,
        tb_display_flow_custom_base_time_unit,
        tb_display_flow_custom_volume_unit_label,
        tb_display_flow_custom_time_unit_label,
        tb_display_flow_custom_volume_unit_multiplier,
        tb_display_flow_custom_time_unit_multiplier,
        tb_display_flow_quality_delta,
        tb_display_gvf_decimal_places,
        tb_display_sos_measurement_units,
        tb_display_sos_quality_delta,
        tb_system_system_config_mode,
        tb_system_update_rate,
        tb_system_sensors_in_use,
        tb_system_transmitter_gain,
        tb_system_spl_threshold,
        tb_system_write_protect,
        tb_system_idle_timeout,
        tb_system_ethernet_idle_timeout,
        tb_system_out_of_range_mode,
        tb_system_dynamic_spl_average,
        tb_system_dynamic_spl_std_dev,
        tb_preamp_gain,
        tb_preamp_auto_gain_mode,
        tb_preamp_charge_gain,
        tb_preamp_gain_0,
        tb_preamp_gain_1,
        tb_preamp_gain_2,
        tb_preamp_gain_3,
        tb_flow_algorithm_flow_sample_freq,
        tb_flow_algorithm_flow_channel_skew,
        tb_flow_algorithm_flow_freq_min,
        tb_flow_algorithm_flow_freq_max,
        tb_flow_algorithm_flow_rate_min,
        tb_flow_algorithm_flow_rate_max,
        tb_flow_algorithm_flow_min_quality,
        tb_flow_algorithm_flow_nyquist_high,
        tb_flow_algorithm_flow_nyquist_low,
        tb_flow_algorithm_flow_centroid_width,
        tb_flow_algorithm_flow_vel_search_limit_low,
        tb_flow_algorithm_flow_vel_search_limit_high,
        tb_flow_algorithm_flow_nyquist_initial_value,
        tb_flow_algorithm_flow_decimation,
        tb_flow_algorithm_flow_window_type,
        tb_flow_algorithm_flow_detrend,
        tb_flow_algorithm_flow_normalization,
        tb_flow_algorithm_flow_differencing,
        tb_flow_algorithm_flow_window_averages,
        tb_flow_algorithm_flow_direction,
        tb_flow_algorithm_flow_window_size_multiplier,
        tb_flow_algorithm_flow_peak_search_mode,
        tb_flow_algorithm_flow_operating_mode,
        tb_flow_algorithm_flow_quality_mode,
        tb_flow_algorithm_flow_bi_direction,
        tb_flow_algorithm_dynamic_flow_data_length,
        tb_flow_algorithm_dynamic_flow_window_size,
        tb_flow_algorithm_dynamic_flow_window_overlap,
        tb_flow_algorithm_dynamic_flow_window_averages,
        tb_flow_calibration_flow_cal_coeff_c0,
        tb_flow_calibration_flow_cal_coeff_c1,
        tb_flow_calibration_flow_cal_coeff_c2,
        tb_sos_algorithm_sos_sample_freq,
        tb_sos_algorithm_sos_freq_min,
        tb_sos_algorithm_sos_freq_max,
        tb_sos_algorithm_sos_min,
        tb_sos_algorithm_sos_max,
        tb_sos_algorithm_sos_min_quality,
        tb_sos_algorithm_sos_centroid_width,
        tb_sos_algorithm_sos_frequency_threshold,
        tb_sos_algorithm_sos_min_k,
        tb_sos_algorithm_sos_max_k,
        tb_sos_algorithm_sos_search_limit,
        tb_sos_algorithm_sos_lambda_diam,
        tb_sos_algorithm_sos_total_data,
        tb_sos_algorithm_sos_window_size,
        tb_sos_algorithm_sos_window_overlap,
        tb_sos_algorithm_sos_sub_array_size,
        tb_sos_algorithm_sos_normalization,
        tb_sos_algorithm_sos_differencing,
        tb_sos_algorithm_sos_operating_mode,
        tb_sos_algorithm_sos_selection_threshold,
        tb_sos_algorithm_sos_min_freq_points,
        tb_sos_algorithm_dynamic_sos_valid_freq_pts_right,
        tb_sos_algorithm_dynamic_sos_valid_freq_pts_left,
        tb_spl_acoustic_level_spl_min_freq,
        tb_spl_acoustic_level_spl_max_freq,
        tb_spl_acoustic_level_al_min_freq,
        tb_spl_acoustic_level_al_max_freq,
        tb_spl_acoustic_level_al_fft_points,
        tb_analog_section_analog_sensor_input_units_1,
        tb_analog_section_analog_sensor_input_units_2,
        tb_analog_section_analog_sensor_input_scale_1,
        tb_analog_section_analog_sensor_input_scale_2,
        tb_analog_section_analog_sensor_input_offset_1,
        tb_analog_section_analog_sensor_input_offset_2,
        tb_analog_section_analog_sensor_1_1st_order_damping_filter_enable,
        tb_analog_section_analog_sensor_2_1st_order_damping_filter_enable,
        tb_analog_section_analog_sensor_1_damping_tau,
        tb_analog_section_analog_sensor_2_damping_tau,
        tb_input_units_pressure_input_units,
        tb_input_units_temperature_input_units,
        tb_input_units_input_1_units,
        tb_input_units_input_2_units,
        tb_input_units_input_3_units,
        tb_flow_nr_filter_enable,
        tb_flow_nr_filter_magnitude_selection,
        tb_flow_damping_filter_flow_1st_order_damping_filter_enable,
        tb_flow_damping_filter_flow_damping_tau,
        tb_flow_spike_filter_enable,
        tb_flow_spike_filter_no_flow_length,
        tb_flow_spike_filter_length,
        tb_flow_spike_filter_up_count,
        tb_flow_spike_filter_down_count,
        tb_flow_spike_filter_percentage,
        tb_flow_spike_filter_pct_window_len,
        tb_gvf_nr_filter_enable,
        tb_gvf_nr_filter_magnitude_selection,
        tb_gvf_damping_filter_enable,
        tb_gvf_damping_filter_tau,
        tb_gvf_spike_filter_enable,
        tb_gvf_spike_filter_no_gvf_length,
        tb_gvf_spike_filter_length,
        tb_gvf_spike_filter_up_count,
        tb_gvf_spike_filter_down_count,
        tb_gvf_spike_filter_percentage,
        tb_gvf_spike_filter_filt_pct_window_len,
        tb_sensor_sensorhead_serial_number,
        tb_sensor_threshold_max,
        tb_sensor_threshold_min,
        tb_sensor_band_temp_rating,
        tb_sensor_band_type,
        tb_sensor_band_active_area,
        tb_sensor_scale_temp_source,
        tb_sensor_scale_comp_temperature,
        tb_sensor_scale_temp_factor,
        tb_sensor_spacing_sensor_1_location,
        tb_sensor_spacing_1_2,
        tb_sensor_spacing_1_3,
        tb_sensor_spacing_1_4,
        tb_sensor_spacing_1_5,
        tb_sensor_spacing_1_6,
        tb_sensor_spacing_1_7,
        tb_sensor_spacing_1_8,
        tb_sensor_scale_factor_1,
        tb_sensor_scale_factor_2,
        tb_sensor_scale_factor_3,
        tb_sensor_scale_factor_4,
        tb_sensor_scale_factor_5,
        tb_sensor_scale_factor_6,
        tb_sensor_scale_factor_7,
        tb_sensor_scale_factor_8,
        tb_measured_values_flow_quality,
        tb_measured_values_flow_rate_unfiltered,
        tb_measured_values_pressure,
        tb_measured_values_temperature,
        tb_measured_values_sos_quality,
        tb_measured_values_sos_unfiltered,
        tb_measured_values_sos_flow_rate,
        tb_measured_values_sos_flow_qual,
        tb_measured_values_tlf,
        tb_measured_values_total_tlf,
        tb_measured_values_tlf_unfiltered,
        tb_measured_values_analog_4_20ma_input_1,
        tb_measured_values_analog_4_20ma_input_2,
        tb_measured_values_total_flow_fraction,
        tb_measured_values_total_tlf_fraction,
        tb_measured_values_total_flow_carry,
        tb_measured_values_total_tlf_carry,
        tb_measured_values_system_status,
        tb_flow_rate_value,
        tb_flow_rate_status,
        tb_gvf_value,
        tb_gvf_status,
        tb_sos_value,
        tb_sos_status,
        tb_sensorhead_temperature_value,
        tb_sensorhead_temperature_status,
        tb_total_flow_value,
        tb_total_flow_status,
        tb_acoustic_level_value,
        tb_acoustic_level_status,
        tb_output_0_value,
        tb_output_0_status,
        tb_output_1_value,
        tb_output_1_status,
        tb_output_2_value,
        tb_output_2_status,
        tb_sensor_max_min_sensor_1_max,
        tb_sensor_max_min_sensor_2_max,
        tb_sensor_max_min_sensor_3_max,
        tb_sensor_max_min_sensor_4_max,
        tb_sensor_max_min_sensor_5_max,
        tb_sensor_max_min_sensor_6_max,
        tb_sensor_max_min_sensor_7_max,
        tb_sensor_max_min_sensor_8_max,
        tb_sensor_max_min_sensor_1_min,
        tb_sensor_max_min_sensor_2_min,
        tb_sensor_max_min_sensor_3_min,
        tb_sensor_max_min_sensor_4_min,
        tb_sensor_max_min_sensor_5_min,
        tb_sensor_max_min_sensor_6_min,
        tb_sensor_max_min_sensor_7_min,
        tb_sensor_max_min_sensor_8_min,
        tb_sensor_alpha_1,
        tb_sensor_alpha_2,
        tb_sensor_alpha_3,
        tb_sensor_alpha_4,
        tb_sensor_alpha_5,
        tb_sensor_alpha_6,
        tb_sensor_alpha_7,
        tb_sensor_alpha_8,
        tb_pressure_input_value,
        tb_pressure_input_status,
        tb_temperature_input_value,
        tb_temperature_input_status,
        tb_input_1_value,
        tb_input_1_status,
        tb_input_2_value,
        tb_input_2_status,
        tb_input_3_value,
        tb_input_3_status,
        tb_pa_slave_info_firmware_revision,
        tb_pa_slave_info_node_address,
        tb_pa_slave_info_block_mode_phy,
        tb_pa_slave_info_block_mode_tb,
        tb_pa_slave_info_slave_mode,
        tb_pa_slave_info_slave_ident_number,
        tb_comm_state,


/*------------- FUNCTION BLOCK 1: AI    ----------------------------------*/

        aifb_tag_desc,
        aifb_channel, 
        aifb_target_mode,
        aifb_actual_mode,
        aifb_pv_upper_range_value,
        aifb_pv_lower_range_value,
        aifb_out_upper_range_value,
        aifb_out_lower_range_value,     
        aifb_out_unit,
        aifb_out_decimal_point,
        aifb_out_value,
        aifb_out_status,
      
/*------------- FUNCTION BLOCK 2: AI    ----------------------------------*/

        aifb_2_tag_desc,
        aifb_2_channel, 
        aifb_2_target_mode,
        aifb_2_actual_mode,
        aifb_2_pv_upper_range_value,
        aifb_2_pv_lower_range_value,
        aifb_2_out_upper_range_value,
        aifb_2_out_lower_range_value,     
        aifb_2_out_unit,
        aifb_2_out_decimal_point,
        aifb_2_out_value,
        aifb_2_out_status,
        
/*------------- FUNCTION BLOCK 3: AI    ----------------------------------*/

        aifb_3_tag_desc,
        aifb_3_channel, 
        aifb_3_target_mode,
        aifb_3_actual_mode,
        aifb_3_pv_upper_range_value,
        aifb_3_pv_lower_range_value,
        aifb_3_out_upper_range_value,
        aifb_3_out_lower_range_value,     
        aifb_3_out_unit,
        aifb_3_out_decimal_point,
        aifb_3_out_value,
        aifb_3_out_status,
        
/*------------- FUNCTION BLOCK 4: AI    ----------------------------------*/

        aifb_4_tag_desc,
        aifb_4_channel, 
        aifb_4_target_mode,
        aifb_4_actual_mode,
        aifb_4_pv_upper_range_value,
        aifb_4_pv_lower_range_value,
        aifb_4_out_upper_range_value,
        aifb_4_out_lower_range_value,     
        aifb_4_out_unit,
        aifb_4_out_decimal_point,
        aifb_4_out_value,
        aifb_4_out_status,
        
/*------------- FUNCTION BLOCK 5: AI    ----------------------------------*/

        aifb_5_tag_desc,
        aifb_5_channel, 
        aifb_5_target_mode,
        aifb_5_actual_mode,
        aifb_5_pv_upper_range_value,
        aifb_5_pv_lower_range_value,
        aifb_5_out_upper_range_value,
        aifb_5_out_lower_range_value,     
        aifb_5_out_unit,
        aifb_5_out_decimal_point,
        aifb_5_out_value,
        aifb_5_out_status,
        
/*------------- FUNCTION BLOCK 6: AI    ----------------------------------*/
              
        aifb_6_tag_desc,
        aifb_6_channel, 
        aifb_6_target_mode,
        aifb_6_actual_mode,
        aifb_6_pv_upper_range_value,
        aifb_6_pv_lower_range_value,
        aifb_6_out_upper_range_value,
        aifb_6_out_lower_range_value,     
        aifb_6_out_unit,
        aifb_6_out_decimal_point,
        aifb_6_out_value,
        aifb_6_out_status,
        
/*------------- FUNCTION BLOCK 7: AI    ----------------------------------*/

        aifb_7_tag_desc,
        aifb_7_channel, 
        aifb_7_target_mode,
        aifb_7_actual_mode,
        aifb_7_pv_upper_range_value,
        aifb_7_pv_lower_range_value,
        aifb_7_out_upper_range_value,
        aifb_7_out_lower_range_value,     
        aifb_7_out_unit,
        aifb_7_out_decimal_point,
        aifb_7_out_value,
        aifb_7_out_status,
        
/*------------- FUNCTION BLOCK 8: AI    ----------------------------------*/

        aifb_8_tag_desc,
        aifb_8_channel, 
        aifb_8_target_mode,
        aifb_8_actual_mode,
        aifb_8_pv_upper_range_value,
        aifb_8_pv_lower_range_value,
        aifb_8_out_upper_range_value,
        aifb_8_out_lower_range_value,     
        aifb_8_out_unit,
        aifb_8_out_decimal_point,
        aifb_8_out_value,
        aifb_8_out_status,
        
/*------------- FUNCTION BLOCK 9: AI    ----------------------------------*/

        aifb_9_tag_desc,
        aifb_9_channel, 
        aifb_9_target_mode,
        aifb_9_actual_mode,
        aifb_9_pv_upper_range_value,
        aifb_9_pv_lower_range_value,
        aifb_9_out_upper_range_value,
        aifb_9_out_lower_range_value,     
        aifb_9_out_unit,
        aifb_9_out_decimal_point,
        aifb_9_out_value,
        aifb_9_out_status,                                                                      

/*------------- FUNCTION BLOCK 10: AO    ----------------------------------*/
        
        aofb_in_channel,
        aofb_out_channel, 
        aofb_target_mode,
        aofb_actual_mode,

        aofb_pv_upper_range_value, 
        aofb_pv_lower_range_value, 
        aofb_pv_unit, 
        aofb_pv_decimal_point

        aofb_out_upper_range_value, 
        aofb_out_lower_range_value, 
        aofb_out_unit, 
        aofb_out_decimal_point

        aofb_out_value,
        aofb_out_status,
        
/*------------- FUNCTION BLOCK 11: AO    ----------------------------------*/
        
        aofb_2_in_channel,
        aofb_2_out_channel, 
        aofb_2_target_mode,
        aofb_2_actual_mode,

        aofb_2_pv_upper_range_value, 
        aofb_2_pv_lower_range_value, 
        aofb_2_pv_unit, 
        aofb_2_pv_decimal_point

        aofb_2_out_upper_range_value, 
        aofb_2_out_lower_range_value, 
        aofb_2_out_unit, 
        aofb_2_out_decimal_point

        aofb_2_out_value,
        aofb_2_out_status,
        
/*------------- FUNCTION BLOCK 12: AO    ----------------------------------*/
        
        aofb_3_in_channel,
        aofb_3_out_channel, 
        aofb_3_target_mode,
        aofb_3_actual_mode,

        aofb_3_pv_upper_range_value, 
        aofb_3_pv_lower_range_value, 
        aofb_3_pv_unit, 
        aofb_3_pv_decimal_point

        aofb_3_out_upper_range_value, 
        aofb_3_out_lower_range_value, 
        aofb_3_out_unit, 
        aofb_3_out_decimal_point

        aofb_3_out_value,
        aofb_3_out_status,
        
/*------------- FUNCTION BLOCK 13: AO    ----------------------------------*/
        
        aofb_4_in_channel,
        aofb_4_out_channel, 
        aofb_4_target_mode,
        aofb_4_actual_mode,

        aofb_4_pv_upper_range_value, 
        aofb_4_pv_lower_range_value, 
        aofb_4_pv_unit, 
        aofb_4_pv_decimal_point

        aofb_4_out_upper_range_value, 
        aofb_4_out_lower_range_value, 
        aofb_4_out_unit, 
        aofb_4_out_decimal_point

        aofb_4_out_value,
        aofb_4_out_status,
        
/*------------- FUNCTION BLOCK 14: AO    ----------------------------------*/
        
        aofb_5_in_channel,
        aofb_5_out_channel, 
        aofb_5_target_mode,
        aofb_5_actual_mode,

        aofb_5_pv_upper_range_value, 
        aofb_5_pv_lower_range_value, 
        aofb_5_pv_unit, 
        aofb_5_pv_decimal_point

        aofb_5_out_upper_range_value, 
        aofb_5_out_lower_range_value, 
        aofb_5_out_unit, 
        aofb_5_out_decimal_point

        aofb_5_out_value,
        aofb_5_out_status                                
    }
}

/******************************************************************************/
MENU upload_variables
{
    LABEL   [menu_load_to_device];
    ITEMS
    {

/*------------- PHYSICAL BLOCK  ---------------------------------------------*/
        
        phys_descriptor,
        phys_message,
        phys_install_date,
        phys_tag_desc,

/*------------- TRANDSDUCER BLOCK 1: AITB   ------------------------------*/

        IF ( ( tb_actual_mode == BLOCK_MODE_OUT_OF_SERVICE ) && ( tb_target_mode == BLOCK_MODE_AUTO ) )
        {
          tb_target_mode,
        }
        ELSE
        {
          tb_target_mode,
          tb_control_write_control,
          tb_control_reset_totalizer,
          tb_control_clear_alarm,
          tb_control_clear_data_history,
          tb_pipe_info_pipe_diameter_input_mode,
          tb_pipe_info_pipe_diameter_units,
          tb_pipe_info_pipe_id,
          tb_pipe_info_pipe_od,
          tb_pipe_info_pipe_od_wall_units,
          tb_pipe_info_pipe_wall_thickness,
          tb_pipe_info_pipe_size,
          tb_pipe_info_pipe_schedule,
          tb_pipe_info_sos_pipe_wall_thickness_units,
          tb_pipe_info_sos_pipe_wall_thickness,
          tb_pipe_info_sos_pipe_modulus_selection,
          tb_pipe_info_sos_pipe_modulus,
          tb_fluid_properties_flow_viscosity,
          tb_fluid_properties_sos_gas_constant_selection,
          tb_fluid_properties_sos_specfic_gravity_selection,
          tb_fluid_properties_sos_liquid_sound_speed_selection,
          tb_fluid_properties_sos_gas_constant,
          tb_fluid_properties_sos_specific_gravity,
          tb_fluid_properties_sos_liquid_sound_speed,
          tb_fluid_properties_sos_polytropic_exponent,
          /*tb_fluid_properties_sos_liquid_density,*/
          tb_environment_sos_temperature_input_selection,
          tb_environment_sos_pressure_input_selection,
          tb_environment_sos_temperature_units,
          tb_environment_sos_pressure_units,
          tb_environment_sos_process_temperature,
          tb_environment_sos_process_pressure,
          tb_environment_altitude_units,
          tb_environment_altitude,
          tb_display_flow_volume_units,
          tb_display_flow_time_units,
          tb_display_flow_low_cutoff_pct,
          tb_display_flow_high_cutoff_pct,
          tb_display_flow_custom_base_volume_unit,
          tb_display_flow_custom_base_time_unit,
          tb_display_flow_custom_volume_unit_label,
          tb_display_flow_custom_time_unit_label,
          tb_display_flow_custom_volume_unit_multiplier,
          tb_display_flow_custom_time_unit_multiplier,
          tb_display_flow_quality_delta,
          tb_display_gvf_decimal_places,
          tb_display_sos_measurement_units,
          tb_display_sos_quality_delta,
          tb_system_system_config_mode,
          tb_system_update_rate,
          tb_system_sensors_in_use,
          tb_system_transmitter_gain,
          tb_system_spl_threshold,
          tb_system_write_protect,
          tb_system_idle_timeout,
          tb_system_ethernet_idle_timeout,
          tb_system_out_of_range_mode,
          tb_preamp_gain,
          tb_preamp_auto_gain_mode,
          tb_flow_algorithm_flow_sample_freq,
          tb_flow_algorithm_flow_channel_skew,
          tb_flow_algorithm_flow_freq_min,
          tb_flow_algorithm_flow_freq_max,
          tb_flow_algorithm_flow_rate_min,
          tb_flow_algorithm_flow_rate_max,
          tb_flow_algorithm_flow_min_quality,
          tb_flow_algorithm_flow_nyquist_high,
          tb_flow_algorithm_flow_nyquist_low,
          tb_flow_algorithm_flow_centroid_width,
          tb_flow_algorithm_flow_vel_search_limit_low,
          tb_flow_algorithm_flow_vel_search_limit_high,
          tb_flow_algorithm_flow_nyquist_initial_value,
          tb_flow_algorithm_flow_decimation,
          tb_flow_algorithm_flow_window_type,
          tb_flow_algorithm_flow_detrend,
          tb_flow_algorithm_flow_normalization,
          tb_flow_algorithm_flow_differencing,
          tb_flow_algorithm_flow_window_averages,
          tb_flow_algorithm_flow_direction,
          tb_flow_algorithm_flow_window_size_multiplier,
          tb_flow_algorithm_flow_peak_search_mode,
          tb_flow_algorithm_flow_operating_mode,
          tb_flow_algorithm_flow_quality_mode,
          tb_flow_algorithm_flow_bi_direction,
          tb_flow_algorithm_dynamic_flow_data_length,
          tb_flow_algorithm_dynamic_flow_window_size,
          tb_flow_algorithm_dynamic_flow_window_overlap,
          tb_flow_algorithm_dynamic_flow_window_averages,
          tb_flow_calibration_flow_cal_coeff_c0,
          tb_flow_calibration_flow_cal_coeff_c1,
          tb_flow_calibration_flow_cal_coeff_c2,
          tb_sos_algorithm_sos_sample_freq,
          tb_sos_algorithm_sos_freq_min,
          tb_sos_algorithm_sos_freq_max,
          tb_sos_algorithm_sos_min,
          tb_sos_algorithm_sos_max,
          tb_sos_algorithm_sos_min_quality,
          tb_sos_algorithm_sos_centroid_width,
          tb_sos_algorithm_sos_frequency_threshold,
          tb_sos_algorithm_sos_min_k,
          tb_sos_algorithm_sos_max_k,
          tb_sos_algorithm_sos_search_limit,
          tb_sos_algorithm_sos_lambda_diam,
          tb_sos_algorithm_sos_total_data,
          tb_sos_algorithm_sos_window_size,
          tb_sos_algorithm_sos_window_overlap,
          tb_sos_algorithm_sos_sub_array_size,
          tb_sos_algorithm_sos_normalization,
          tb_sos_algorithm_sos_differencing,
          tb_sos_algorithm_sos_operating_mode,
          tb_sos_algorithm_sos_selection_threshold,
          tb_sos_algorithm_sos_min_freq_points,
          tb_spl_acoustic_level_spl_min_freq,
          tb_spl_acoustic_level_spl_max_freq,
          tb_spl_acoustic_level_al_min_freq,
          tb_spl_acoustic_level_al_max_freq,
          tb_spl_acoustic_level_al_fft_points,
          tb_analog_section_analog_sensor_input_units_1,
          tb_analog_section_analog_sensor_input_units_2,
          tb_analog_section_analog_sensor_input_scale_1,
          tb_analog_section_analog_sensor_input_scale_2,
          tb_analog_section_analog_sensor_input_offset_1,
          tb_analog_section_analog_sensor_input_offset_2,
          tb_analog_section_analog_sensor_1_1st_order_damping_filter_enable,
          tb_analog_section_analog_sensor_2_1st_order_damping_filter_enable,
          tb_analog_section_analog_sensor_1_damping_tau,
          tb_analog_section_analog_sensor_2_damping_tau,
          tb_input_units_pressure_input_units,
          tb_input_units_temperature_input_units,
          tb_input_units_input_1_units,
          tb_input_units_input_2_units,
          tb_input_units_input_3_units,
          tb_flow_nr_filter_enable,
          tb_flow_nr_filter_magnitude_selection,
          tb_flow_damping_filter_flow_1st_order_damping_filter_enable,
          tb_flow_damping_filter_flow_damping_tau,
          tb_flow_spike_filter_enable,
          tb_flow_spike_filter_no_flow_length,
          tb_flow_spike_filter_length,
          tb_flow_spike_filter_up_count,
          tb_flow_spike_filter_down_count,
          tb_flow_spike_filter_percentage,
          tb_flow_spike_filter_pct_window_len,
          tb_gvf_nr_filter_enable,
          tb_gvf_nr_filter_magnitude_selection,
          tb_gvf_damping_filter_enable,
          tb_gvf_damping_filter_tau,
          tb_gvf_spike_filter_enable,
          tb_gvf_spike_filter_no_gvf_length,
          tb_gvf_spike_filter_length,
          tb_gvf_spike_filter_up_count,
          tb_gvf_spike_filter_down_count,
          tb_gvf_spike_filter_percentage,
          tb_gvf_spike_filter_filt_pct_window_len,
          tb_sensor_sensorhead_serial_number,
          tb_sensor_threshold_max,
          tb_sensor_threshold_min,
          tb_sensor_band_temp_rating,
          tb_sensor_band_type,
          tb_sensor_band_active_area,
          tb_sensor_scale_temp_source,
          tb_sensor_scale_comp_temperature,
          tb_sensor_spacing_sensor_1_location,
          tb_sensor_spacing_1_2,
          tb_sensor_spacing_1_3,
          tb_sensor_spacing_1_4,
          tb_sensor_spacing_1_5,
          tb_sensor_spacing_1_6,
          tb_sensor_spacing_1_7,
          tb_sensor_spacing_1_8,
          tb_sensor_scale_factor_1,
          tb_sensor_scale_factor_2,
          tb_sensor_scale_factor_3,
          tb_sensor_scale_factor_4,
          tb_sensor_scale_factor_5,
          tb_sensor_scale_factor_6,
          tb_sensor_scale_factor_7,
          tb_sensor_scale_factor_8,
        }

/*------------- FUNCTION BLOCK 1: AI    ----------------------------------*/

        aifb_target_mode,
        aifb_channel, 
        aifb_pv_upper_range_value,
        aifb_pv_lower_range_value,
        aifb_out_upper_range_value,
        aifb_out_lower_range_value,     
        aifb_out_unit,
        aifb_out_decimal_point,
        IF (aifb_actual_mode == BLOCK_MODE_MAN)
        {
          aifb_out_value,
          aifb_out_status,
        }
        
/*------------- FUNCTION BLOCK 2: AI    ----------------------------------*/

        aifb_2_target_mode,
        aifb_2_channel, 
        aifb_2_pv_upper_range_value,
        aifb_2_pv_lower_range_value,
        aifb_2_out_upper_range_value,
        aifb_2_out_lower_range_value,     
        aifb_2_out_unit,
        aifb_2_out_decimal_point,
        IF (aifb_2_actual_mode == BLOCK_MODE_MAN)
        {
          aifb_2_out_value,
          aifb_2_out_status,
        }
        
/*------------- FUNCTION BLOCK 3: AI    ----------------------------------*/

        aifb_3_target_mode,
        aifb_3_channel,
        aifb_3_pv_upper_range_value,
        aifb_3_pv_lower_range_value,
        aifb_3_out_upper_range_value,
        aifb_3_out_lower_range_value,     
        aifb_3_out_unit,
        aifb_3_out_decimal_point,
        IF (aifb_3_actual_mode == BLOCK_MODE_MAN)
        {
          aifb_3_out_value,
          aifb_3_out_status,
        }
        
/*------------- FUNCTION BLOCK 4: AI    ----------------------------------*/

        aifb_4_target_mode,
        aifb_4_channel,
        aifb_4_pv_upper_range_value,
        aifb_4_pv_lower_range_value,
        aifb_4_out_upper_range_value,
        aifb_4_out_lower_range_value,     
        aifb_4_out_unit,
        aifb_4_out_decimal_point,
        IF (aifb_4_actual_mode == BLOCK_MODE_MAN)
        {
          aifb_4_out_value,
          aifb_4_out_status,
        }
        
/*------------- FUNCTION BLOCK 5: AI    ----------------------------------*/

        aifb_5_target_mode,
        aifb_5_channel,
        aifb_5_pv_upper_range_value,
        aifb_5_pv_lower_range_value,
        aifb_5_out_upper_range_value,
        aifb_5_out_lower_range_value,     
        aifb_5_out_unit,
        aifb_5_out_decimal_point,
        IF (aifb_5_actual_mode == BLOCK_MODE_MAN)
        {
          aifb_5_out_value,
          aifb_5_out_status,
        }
        
/*------------- FUNCTION BLOCK 6: AI    ----------------------------------*/

        aifb_6_target_mode,
        aifb_6_channel,
        aifb_6_pv_upper_range_value,
        aifb_6_pv_lower_range_value,
        aifb_6_out_upper_range_value,
        aifb_6_out_lower_range_value,     
        aifb_6_out_unit,
        aifb_6_out_decimal_point,
        IF (aifb_6_actual_mode == BLOCK_MODE_MAN)
        {
          aifb_6_out_value,
          aifb_6_out_status,
        }
        
/*------------- FUNCTION BLOCK 7: AI    ----------------------------------*/

        aifb_7_target_mode,
        aifb_7_channel,
        aifb_7_pv_upper_range_value,
        aifb_7_pv_lower_range_value,
        aifb_7_out_upper_range_value,
        aifb_7_out_lower_range_value,     
        aifb_7_out_unit,
        aifb_7_out_decimal_point,
        IF (aifb_7_actual_mode == BLOCK_MODE_MAN)
        {
          aifb_7_out_value,
          aifb_7_out_status,
        }
        
/*------------- FUNCTION BLOCK 8: AI    ----------------------------------*/

        aifb_8_target_mode,
        aifb_8_channel,
        aifb_8_pv_upper_range_value,
        aifb_8_pv_lower_range_value,
        aifb_8_out_upper_range_value,
        aifb_8_out_lower_range_value,     
        aifb_8_out_unit,
        aifb_8_out_decimal_point,
        IF (aifb_8_actual_mode == BLOCK_MODE_MAN)
        {
          aifb_8_out_value,
          aifb_8_out_status,
        }
        
/*------------- FUNCTION BLOCK 9: AI    ----------------------------------*/

        aifb_9_target_mode,
        aifb_9_channel,
        aifb_9_pv_upper_range_value,
        aifb_9_pv_lower_range_value,
        aifb_9_out_upper_range_value,
        aifb_9_out_lower_range_value,     
        aifb_9_out_unit,
        aifb_9_out_decimal_point,
        IF (aifb_9_actual_mode == BLOCK_MODE_MAN)
        {
          aifb_9_out_value,
          aifb_9_out_status,
        }                                                                              

/*------------- FUNCTION BLOCK 10: AO    ----------------------------------*/
        
        aofb_target_mode,
        aofb_in_channel, 
        aofb_out_channel, 

        aofb_pv_upper_range_value, 
        aofb_pv_lower_range_value, 
        aofb_pv_unit, 
        aofb_pv_decimal_point,

        IF (aofb_actual_mode == BLOCK_MODE_MAN)
        {
            aofb_out_value,
            aofb_out_status,
        }
        ELSE
        {
        }
        
        aofb_out_upper_range_value, 
        aofb_out_lower_range_value, 
        aofb_out_unit, 
        aofb_out_decimal_point,

/*------------- FUNCTION BLOCK 11: AO    ----------------------------------*/
        
        aofb_2_target_mode,
        aofb_2_in_channel, 
        aofb_2_out_channel, 

        aofb_2_pv_upper_range_value, 
        aofb_2_pv_lower_range_value, 
        aofb_2_pv_unit, 
        aofb_2_pv_decimal_point,

        IF (aofb_2_actual_mode == BLOCK_MODE_MAN)
        {
            aofb_2_out_value,
            aofb_2_out_status,
        }
        ELSE
        {
        }
        
        aofb_2_out_upper_range_value, 
        aofb_2_out_lower_range_value, 
        aofb_2_out_unit, 
        aofb_2_out_decimal_point,
        
/*------------- FUNCTION BLOCK 12: AO    ----------------------------------*/
        
        aofb_3_target_mode,
        aofb_3_in_channel, 
        aofb_3_out_channel, 

        aofb_3_pv_upper_range_value, 
        aofb_3_pv_lower_range_value, 
        aofb_3_pv_unit, 
        aofb_3_pv_decimal_point,

        IF (aofb_3_actual_mode == BLOCK_MODE_MAN)
        {
            aofb_3_out_value,
            aofb_3_out_status,
        }
        ELSE
        {
        }
        
        aofb_3_out_upper_range_value, 
        aofb_3_out_lower_range_value, 
        aofb_3_out_unit, 
        aofb_3_out_decimal_point,
        
/*------------- FUNCTION BLOCK 13: AO    ----------------------------------*/
        
        aofb_4_target_mode,
        aofb_4_in_channel, 
        aofb_4_out_channel, 

        aofb_4_pv_upper_range_value, 
        aofb_4_pv_lower_range_value, 
        aofb_4_pv_unit, 
        aofb_4_pv_decimal_point,

        IF (aofb_4_actual_mode == BLOCK_MODE_MAN)
        {
            aofb_4_out_value,
            aofb_4_out_status,
        }
        ELSE
        {
        }
        
        aofb_4_out_upper_range_value, 
        aofb_4_out_lower_range_value, 
        aofb_4_out_unit, 
        aofb_4_out_decimal_point,
        
/*------------- FUNCTION BLOCK 14: AO    ----------------------------------*/
        
        aofb_5_target_mode,
        aofb_5_in_channel, 
        aofb_5_out_channel, 

        aofb_5_pv_upper_range_value, 
        aofb_5_pv_lower_range_value, 
        aofb_5_pv_unit, 
        aofb_5_pv_decimal_point,

        IF (aofb_5_actual_mode == BLOCK_MODE_MAN)
        {          
            aofb_5_out_value,
            aofb_5_out_status,
        }
        ELSE
        {
        }
        
        aofb_5_out_upper_range_value, 
        aofb_5_out_lower_range_value, 
        aofb_5_out_unit, 
        aofb_5_out_decimal_point                                

    }
}        
