/*-------------------------------------------------------------------------*/
/*      Copyright (c)      Softing AG 2008                                 */
/*      Product:           EDD for CiDRA SONAR                             */
/*                                                                         */
/*      Device:            CiDRA SONAR     PA 2.20                         */
/*                                                                         */
/*      Communication:     PROFIBUS PA                                     */
/*      Description:       Definition for AOFB                             */
/*      Dictionary:                                                        */
/*      Revision           1.00                                            */
/*      Date:              2008/06/18                                      */
/*      Author:            SHR                                             */
/*-------------------------------------------------------------------------*/

#include "sonar_gen.inc"

BLOCK aofb_3
{
        TYPE    FUNCTION;
        NUMBER  12;
}
/*-------------------------------------------------------------------------*/
/*    AI function Block VARIABLE                                           */
/*-------------------------------------------------------------------------*/
/*    Standard Parameter (0-7)          (See PAprofile.pdf-3.3)            */
/*-------------------------------------------------------------------------*/

aofb_3_blk_reserve    LIKE VARIABLE   phys_blk_reserve
{
}

VARIABLE aofb_3_blk_object
{
        LABEL           [blk_block_object];
        HELP            [blk_block_object_help];
        CLASS           CONTAINED;
        TYPE            ENUMERATED(1)
        {
                {       2,      [blk_block_object_FUNCTION]     }
        }
        HANDLING        READ;
}

VARIABLE aofb_3_blk_parent_class
{
        LABEL           [blk_parent_class];
        HELP            [func_blk_parent_class_help];
        CLASS           CONTAINED;
        TYPE            ENUMERATED(1)
        {
                {       1,      [func_blk_parent_class_INPUT]   }
        }
        HANDLING        READ;
}

VARIABLE aofb_3_blk_class
{
        LABEL           [blk_class];
        HELP            [func_blk_class_help];
        CLASS           CONTAINED;
        TYPE            ENUMERATED(1)
        {
                {       1,      [func_blk_class_AO]     }
        }
        HANDLING        READ;
}

aofb_3_blk_dd_reference       LIKE VARIABLE   phys_blk_dd_reference
{
}

aofb_3_blk_dd_rev             LIKE VARIABLE   phys_blk_dd_rev
{
}

aofb_3_blk_profile            LIKE VARIABLE   phys_blk_profile
{
}

aofb_3_blk_profile_rev        LIKE VARIABLE   phys_blk_profile_rev
{
}

aofb_3_blk_execution_time     LIKE VARIABLE   phys_blk_execution_time
{
}

aofb_3_blk_num_parameters     LIKE VARIABLE   phys_blk_num_parameters
{
}

aofb_3_blk_index_view_1       LIKE VARIABLE   phys_blk_index_view_1
{
}

aofb_3_blk_num_view_lists     LIKE VARIABLE   phys_blk_num_view_lists
{
}
/*-------------------------------------------------------------------------*/
aofb_3_st_rev                 LIKE VARIABLE   phys_st_rev
{
        REDEFINE LABEL          "AO ST_REV";
}
/*-------------------------------------------------------------------------*/
aofb_3_tag_desc               LIKE VARIABLE   phys_tag_desc
{
        REDEFINE LABEL          "AOFB Tag";
}
/*-------------------------------------------------------------------------*/
aofb_3_strategy               LIKE VARIABLE   phys_strategy
{
}
/*-------------------------------------------------------------------------*/
aofb_3_alert_key              LIKE VARIABLE   phys_alert_key
{
}
/*-------------------------------------------------------------------------*/
VARIABLE aofb_3_target_mode
{
        LABEL           "Target Mode";
        HELP            [target_mode_help];
        CLASS           CONTAINED;
        TYPE            ENUMERATED (1)
        {
                DEFAULT_VALUE   0x08;
                {       0x08,   [mode_AUTO]             },
                {       0x10,   [mode_MAN]              },
                {       0x80,   [mode_OUT_OF_SERVICE]   }
        }
        HANDLING        READ & WRITE;
}
/*-------------------------------------------------------------------------*/
VARIABLE aofb_3_actual_mode
{
        LABEL           "Actual Mode";
        HELP            [actual_mode_help];
        CLASS           CONTAINED & DYNAMIC;
        TYPE            ENUMERATED (1)
        {
                DEFAULT_VALUE   0x08;
                {       0x08,   [mode_AUTO]             },
                {       0x10,   [mode_MAN]              },
                {       0x80,   [mode_OUT_OF_SERVICE]   }
        }
        HANDLING        READ;
}

VARIABLE aofb_3_permitted_mode
{
        LABEL           [permitted_mode];
        HELP            [permitted_mode_help];
        CLASS           CONTAINED;
        TYPE            BIT_ENUMERATED (1)
        {
                DEFAULT_VALUE   0x08;
                {       0x08,   [mode_AUTO]             },
                {       0x10,   [mode_MAN]              },
                {       0x80,   [mode_OUT_OF_SERVICE]   }
        }
        HANDLING        READ;
}

VARIABLE aofb_3_normal_mode
{
        LABEL           [normal_mode];
        HELP            [normal_mode_help];
        CLASS           CONTAINED;
        TYPE            ENUMERATED (1)
        {
                DEFAULT_VALUE   0x08;
                {       0x08,   [mode_AUTO]             },
                {       0x10,   [mode_MAN]              },
                {       0x80,   [mode_OUT_OF_SERVICE]   }
        }
        HANDLING        READ;
}
/*-------------------------------------------------------------------------*/
aofb_3_current_state_alarm_sum        LIKE VARIABLE   phys_current_state_alarm_sum
{
        REDEFINE TYPE           BIT_ENUMERATED (2)
        {
                {       0x0000, [limit_state_NO_ALARM]  },
                {       0x0200, [limit_state_HI_HI]     },
                {       0x0400, [limit_state_HI]        },
                {       0x0800, [limit_state_LO_LO]     },
                {       0x1000, [limit_state_LO]        },
                {       0x8000, [limit_state_ST_REV]    }
        }

}

aofb_3_unacknowledged_state_alarm_sum LIKE VARIABLE   phys_unacknowledged_state_alarm_sum
{
        REDEFINE TYPE           BIT_ENUMERATED (2)
        {
                {       0x0000, [limit_state_NO_ALARM]  },
                {       0x0200, [limit_state_HI_HI]     },
                {       0x0400, [limit_state_HI]        },
                {       0x0800, [limit_state_LO_LO]     },
                {       0x1000, [limit_state_LO]        },
                {       0x8000, [limit_state_ST_REV]    }
        }
}

aofb_3_unreported_state_alarm_sum     LIKE VARIABLE   phys_unreported_state_alarm_sum
{
        REDEFINE TYPE           BIT_ENUMERATED (2)
        {
                {       0x0000, [limit_state_NO_ALARM]  },
                {       0x0200, [limit_state_HI_HI]     },
                {       0x0400, [limit_state_HI]        },
                {       0x0800, [limit_state_LO_LO]     },
                {       0x1000, [limit_state_LO]        },
                {       0x8000, [limit_state_ST_REV]    }
        }
}

aofb_3_disabled_state_alarm_sum       LIKE VARIABLE   phys_disabled_state_alarm_sum
{
        REDEFINE TYPE           BIT_ENUMERATED (2)
        {
                {       0x0000, [limit_state_NO_ALARM]  },
                {       0x0200, [limit_state_HI_HI]     },
                {       0x0400, [limit_state_HI]        },
                {       0x0800, [limit_state_LO_LO]     },
                {       0x1000, [limit_state_LO]        },
                {       0x8000, [limit_state_ST_REV]    }
        }
}

/*-------------------------------------------------------------------------*/
/*    Function Parameter (8,10-35)                                         */
/*-------------------------------------------------------------------------*/
/* Batch Parameter (BATCH) standard for Function Blocks (DS-67)            */
/*-------------------------------------------------------------------------*/
VARIABLE aofb_3_batch_id                                /* index 8 */
{
        LABEL           [func_batch_id];
        HELP            [func_batch_id_help];
        CLASS           CONTAINED;
        TYPE            UNSIGNED_INTEGER (4)
        {
                DEFAULT_VALUE   0;
        }
        HANDLING        READ & WRITE;
}

VARIABLE aofb_3_batch_unit
{
        LABEL           [func_batch_unit];
        HELP            [func_batch_unit_help];
        CLASS           CONTAINED;
        TYPE            UNSIGNED_INTEGER (2)
        {
                DEFAULT_VALUE   0;
        }
        HANDLING        READ & WRITE;
}

VARIABLE aofb_3_batch_operation
{
        LABEL           [func_batch_operation];
        HELP            [func_batch_operation_help];
        CLASS           CONTAINED;
        TYPE            UNSIGNED_INTEGER (2)
        {
                DEFAULT_VALUE   0;
        }
        HANDLING        READ & WRITE;
}

VARIABLE aofb_3_batch_phase
{
        LABEL           [func_batch_phase];
        HELP            [func_batch_phase_help];
        CLASS           CONTAINED;
        TYPE            UNSIGNED_INTEGER (2)
        {
                DEFAULT_VALUE   0;
        }
        HANDLING        READ & WRITE;
}



/*------------------------------------------------------ index 9 ----------*/

VARIABLE aofb_3_sp_value
{
  LABEL   [func_ao_setpoint_value];
  HELP    [func_ao_setpoint_value_help];
  CLASS   CONTAINED & DYNAMIC;
  TYPE    FLOAT;
  HANDLING  READ & WRITE;
}


VARIABLE aofb_3_sp_status
{
  LABEL   [func_ao_setpoint_status];
  HELP    [func_ao_setpoint_status_help];
  CLASS   CONTAINED & DYNAMIC;
  TYPE    ENUMERATED (1)
  {
    DEFAULT_VALUE 0x18;
    STATUS_GENERAL
  }
  HANDLING  READ & WRITE;
}

VARIABLE aofb_3_pv_upper_range_value
{
  LABEL   [func_pv_scale_upper_value];
  HELP    [func_pv_scale_upper_value_help];
  CLASS   CONTAINED;
  TYPE         FLOAT
  {
    DEFAULT_VALUE 100.0;
  }
  HANDLING  READ & WRITE;
}

VARIABLE aofb_3_pv_lower_range_value
{
  LABEL   [func_pv_scale_lower_value];
  HELP    [func_pv_scale_lower_value_help];
  CLASS     CONTAINED;
  TYPE        FLOAT
  {
    DEFAULT_VALUE 0.0;
  }
  HANDLING  READ & WRITE;
}

VARIABLE aofb_3_pv_unit
{
  LABEL   [func_pv_scale_unit];
  HELP    [func_pv_scale_unit_help];
  CLASS   CONTAINED;
  TYPE    ENUMERATED (2)
  {
    DEFAULT_VALUE     32768;
    UNIT_LIST
  }
  HANDLING  READ & WRITE;
}

VARIABLE aofb_3_pv_decimal_point
{
  LABEL   [decimal_point];
  HELP    [decimal_point_help];
  CLASS   CONTAINED;
  TYPE    ENUMERATED (1)
  {
    DEFAULT_VALUE 0;
    { 0,   "0"    },
    { 1,   "1"    },
    { 2,   "2"    },
    { 3,   "3"    },
    { 4,   "4"    },
    { 5,   "5"    },
    { 6,   "6"    }
  }
  HANDLING  READ & WRITE;
}

VARIABLE aofb_3_readback_value
{
  LABEL   [func_ao_readback_value];
  HELP    [func_ao_readback_value_help];
  CLASS   CONTAINED & DYNAMIC;
  TYPE    FLOAT;
  HANDLING  READ;
}

VARIABLE aofb_3_readback_status
{
  LABEL   [func_ao_readback_status];
  HELP    [func_ao_readback_status_help];
  CLASS   CONTAINED & DYNAMIC;
  TYPE    ENUMERATED (1);
  HANDLING  READ;
}

VARIABLE aofb_3_rcas_in_value
{
  LABEL   [func_rcas_in_value];
  HELP    [func_rcas_in_value_help];
  CLASS   CONTAINED & DYNAMIC;
  TYPE    FLOAT;
  HANDLING  READ & WRITE;
}

VARIABLE aofb_3_rcas_in_status
{
  LABEL   [func_rcas_in_status];
  HELP    [func_rcas_in_status_help];
  CLASS   CONTAINED;
  TYPE    ENUMERATED (1)
  {
    DEFAULT_VALUE 0x18;
    STATUS_GENERAL
  }
  HANDLING  READ & WRITE;
}


VARIABLE aofb_3_in_channel
{
  LABEL   "AO In Channel";
  CLASS   CONTAINED;
        TYPE            ENUMERATED (2)
        {
                DEFAULT_VALUE 309;
                { 307, "Pressure Input" },
                { 308, "Temperature Input" },
                { 309, "Input 1" },
                { 310, "Input 2" },
                { 311, "Input 3" }
        }
  HANDLING  READ & WRITE;
}


VARIABLE aofb_3_out_channel
{
  LABEL   "AO Out Channel";
  CLASS   CONTAINED;
        TYPE            ENUMERATED (2)
        {
                DEFAULT_VALUE 309;
                { 307, "Pressure Input" },
                { 308, "Temperature Input" },
                { 309, "Input 1" },
                { 310, "Input 2" },
                { 311, "Input 3" }
        }
  HANDLING  READ & WRITE;
}


VARIABLE aofb_3_fsafe_time
{
  LABEL   [func_ao_fsafe_time];
  HELP    [func_ao_fsafe_time_help];
  CLASS   CONTAINED;
  TYPE    FLOAT
  {
    DEFAULT_VALUE 0.0;
  }
  CONSTANT_UNIT [sec];
  HANDLING  READ & WRITE;
}

VARIABLE aofb_3_fsafe_type
{
  LABEL   [func_ao_fsafe_type];
  HELP    [func_ao_fsafe_type_help];
  CLASS   CONTAINED;
  TYPE    ENUMERATED (1)
  {
    DEFAULT_VALUE 2;
    { 0,  [func_ao_fsafe_type_FAIL_SAFE_VALUE]    },
    { 1,  [func_ao_fsafe_type_STORING_LAST_SETPOINT]  },
    { 2,  [func_ao_fsafe_type_FAIL_SAFE_POSITION]   }
  }
  HANDLING  READ & WRITE;
}

VARIABLE aofb_3_fsafe_value
{
  LABEL   [func_ao_fsafe_value];
  HELP    [func_ao_fsafe_value_help];
  CLASS   CONTAINED;
  TYPE    FLOAT
  {
    DEFAULT_VALUE 0.0;
  }
  HANDLING  READ & WRITE;
}

VARIABLE aofb_3_rcas_out_value
{
  LABEL   [func_rcas_out_value];
  HELP    [func_rcas_out_value_help];
  CLASS   CONTAINED & DYNAMIC;
  TYPE    FLOAT;
  HANDLING  READ;
}

VARIABLE aofb_3_rcas_out_status
{
  LABEL   [func_rcas_out_status];
  HELP    [func_rcas_out_status_help];
  CLASS   CONTAINED & DYNAMIC;
  TYPE    ENUMERATED (1);
  HANDLING  READ;
}

VARIABLE aofb_3_position_discrete_value
{
  LABEL   [func_ao_position_discrete_value];
  HELP    [func_ao_position_discrete_value_help];
  CLASS   CONTAINED & DYNAMIC;
  TYPE    ENUMERATED (1)
  {
    { 0,  [func_ao_position_discrete_status_NOT_INIT]     },
    { 1,  [func_ao_position_discrete_status_CLOSED]     },
    { 2,  [func_ao_position_discrete_status_OPENED]     },
    { 3,  [func_ao_position_discrete_status_INTERMEDIATE]   }
  }
  HANDLING  READ;
}

VARIABLE aofb_3_position_discrete_status
{
  LABEL   [func_ao_position_discrete_status];
  HELP    [func_ao_position_discrete_status_help];
  CLASS   CONTAINED & DYNAMIC;
  TYPE    ENUMERATED (1);
  HANDLING  READ;
}

VARIABLE aofb_3_setpoint_deviation
{
  LABEL   [func_ao_setpoint_deviation];
  HELP    [func_ao_setpoint_deviation_help];
  CLASS   CONTAINED & DYNAMIC;
  TYPE    FLOAT;
  CONSTANT_UNIT [Percent];
  HANDLING  READ;
}

VARIABLE aofb_3_check_back
{
  LABEL   [func_check_back];
  HELP    [func_check_back_help];
  CLASS   CONTAINED & DYNAMIC;
  TYPE    BIT_ENUMERATED (3);
  HANDLING  READ;
}

VARIABLE aofb_3_check_back_mask
{
  LABEL   [func_check_back_mask];
  HELP    [func_check_back_mask_help];
  CLASS   CONTAINED;
  TYPE    BIT_ENUMERATED (3)
  {
    { CB_FAIL_SAFE,   [cb_FAIL_SAFE],     [cb_FAIL_SAFE_help]     },
    { CB_SIMULATE,    [cb_SIMULATE],      [cb_SIMULATE_help]      },
    { CB_CONTR_INACT,   [cb_CONTR_INACT],   [cb_CONTR_INACT_help]     }
  }
  HANDLING  READ;
}

VARIABLE aofb_3_simulate_value
{
  LABEL   [func_simulate_value];
  HELP    [func_ao_simulate_value_help];
  CLASS   CONTAINED;
  TYPE    FLOAT
  {
    DEFAULT_VALUE 0.0;
  }
  HANDLING  READ & WRITE;
}

VARIABLE aofb_3_simulate_status
{
  LABEL   [func_simulate_status];
  HELP    [func_simulate_status_help];
  CLASS   CONTAINED;
  TYPE    ENUMERATED (1)
  {
    DEFAULT_VALUE 0;
  }
  HANDLING  READ & WRITE;
}

VARIABLE aofb_3_simulation_enabled
{
  LABEL   [func_simulation_enabled];
  HELP    [func_simulation_enabled_help];
  CLASS   CONTAINED;
  TYPE    ENUMERATED (1)
  {
    DEFAULT_VALUE 0;
    { 0,  [disabled]    },
    { 1,  [enabled]   }
  }
  HANDLING  READ & WRITE;
}

VARIABLE aofb_3_increase_close
{
  LABEL   [func_ao_increase_close];
  HELP    [func_ao_increase_close_help];
  CLASS   CONTAINED;
  TYPE    ENUMERATED (1)
  {
    DEFAULT_VALUE 0;
    { 0,  [func_ao_increase_close_RISING]   },
    { 1,  [func_ao_increase_close_FALLING]  }
  }
  HANDLING  READ & WRITE;
}

VARIABLE aofb_3_out_value
{
  LABEL   [func_out_value];
  HELP    [func_ao_out_value_help];
  CLASS   CONTAINED & DYNAMIC;
  TYPE    FLOAT;
  HANDLING
        IF (aofb_3_actual_mode == BLOCK_MODE_MAN)
        {
                READ & WRITE;
        }
        ELSE
        {
                READ;
        }
}

VARIABLE aofb_3_out_status
{
  LABEL   [func_out_status];
  HELP    [func_out_status_help];
  CLASS   CONTAINED & DYNAMIC;
  TYPE    ENUMERATED (1);
  HANDLING
        IF (aofb_3_actual_mode == BLOCK_MODE_MAN)
        {
                READ & WRITE;
        }
        ELSE
        {
                READ;
        }
}

VARIABLE aofb_3_out_upper_range_value
{
  LABEL   [func_out_scale_upper_value];
  HELP    [func_out_scale_upper_value_help];
  CLASS   CONTAINED;
  TYPE          FLOAT
  {
    DEFAULT_VALUE 100.0;
  }
  HANDLING  READ & WRITE;
}

VARIABLE aofb_3_out_lower_range_value
{
  LABEL   [func_out_scale_lower_value];
  HELP    [func_out_scale_lower_value_help];
  CLASS   CONTAINED;
  TYPE          FLOAT
  {
    DEFAULT_VALUE 0.0;
  }
  HANDLING  READ & WRITE;
}

VARIABLE aofb_3_out_unit
{
  LABEL   [func_out_scale_unit];
  HELP    [func_out_scale_unit_help];
  CLASS   CONTAINED;
  TYPE    ENUMERATED (2)
  {
    DEFAULT_VALUE     32768;   /*  pressure in BARG */
    UNIT_CIDRA_AO
  }
}

VARIABLE aofb_3_out_decimal_point
{
  LABEL   [decimal_point];
  HELP    [decimal_point_help];
  CLASS   CONTAINED;
  TYPE    ENUMERATED (1)
  {
    DEFAULT_VALUE 0;
    { 0,   "0"    },
    { 1,   "1"    },
    { 2,   "2"    },
    { 3,   "3"    },
    { 4,   "4"    },
    { 5,   "5"    },
    { 6,   "6"    }
  }
  HANDLING  READ & WRITE;
}

/*---------------------------------------------------------------------*/
/*    Function Block COMMAND (AO)                  */
/*---------------------------------------------------------------------*/
/*    Standard Parameter (0-8)                       */
/*---------------------------------------------------------------------*/
COMMAND read_aofb_3_blk
{
  BLOCK aofb_3;
  INDEX 0;
  OPERATION READ;
  TRANSACTION
  {
    REQUEST
    {
    }
    REPLY
    {
      aofb_3_blk_reserve,
      aofb_3_blk_object,
      aofb_3_blk_parent_class,
      aofb_3_blk_class,
      aofb_3_blk_dd_reference,
      aofb_3_blk_dd_rev,
      aofb_3_blk_profile,
      aofb_3_blk_profile_rev,
      aofb_3_blk_execution_time,
                        aofb_3_blk_num_parameters,
                        aofb_3_blk_index_view_1,
                        aofb_3_blk_num_view_lists
    }
  }
}
/*---------------------------------------------------------------------*/
COMMAND read_aofb_3_st_rev
{
  BLOCK aofb_3;
  INDEX 1;
  OPERATION READ;
  TRANSACTION
  {
    REQUEST
    {
    }
    REPLY
    {
      aofb_3_st_rev
    }
  }
}
/*---------------------------------------------------------------------*/
COMMAND read_aofb_3_tag_desc
{
  BLOCK aofb_3;
  INDEX 2;
  OPERATION READ;
  TRANSACTION
  {
    REQUEST
    {
    }
    REPLY
    {
      aofb_3_tag_desc
    }
  }
}

COMMAND write_aofb_3_tag_desc
{
  BLOCK aofb_3;
  INDEX 2;
  OPERATION WRITE;
  TRANSACTION
  {
    REQUEST
    {
      aofb_3_tag_desc
    }
    REPLY
    {
    }
  }
}
/*---------------------------------------------------------------------*/
COMMAND read_aofb_3_strategy
{
  BLOCK aofb_3;
  INDEX 3;
  OPERATION READ;
  TRANSACTION
  {
    REQUEST
    {
    }
    REPLY
    {
      aofb_3_strategy
    }
  }
}

COMMAND write_aofb_3_strategy
{
  BLOCK aofb_3;
  INDEX 3;
  OPERATION WRITE;
  TRANSACTION
  {
    REQUEST
    {
      aofb_3_strategy
    }
    REPLY
    {
    }
  }
}
/*---------------------------------------------------------------------*/
COMMAND read_aofb_3_alert_key
{
  BLOCK aofb_3;
  INDEX 4;
  OPERATION READ;
  TRANSACTION
  {
    REQUEST
    {
    }
    REPLY
    {
      aofb_3_alert_key
    }
  }
}

COMMAND write_aofb_3_alert_key
{
  BLOCK aofb_3;
  INDEX 4;
  OPERATION WRITE;
  TRANSACTION
  {
    REQUEST
    {
      aofb_3_alert_key
    }
    REPLY
    {
    }
  }
}
/*---------------------------------------------------------------------*/
COMMAND read_aofb_3_target_mode
{
  BLOCK aofb_3;
  INDEX 5;
  OPERATION READ;
  TRANSACTION
  {
    REQUEST
    {
    }
    REPLY
    {
      aofb_3_target_mode
    }
  }
}

COMMAND write_aofb_3_target_mode
{
  BLOCK aofb_3;
  INDEX 5;
  OPERATION WRITE;
  TRANSACTION
  {
    REQUEST
    {
      aofb_3_target_mode
    }
    REPLY
    {
    }
  }
}
/*---------------------------------------------------------------------*/
COMMAND read_aofb_3_mode
{
  BLOCK aofb_3;
  INDEX 6;
  OPERATION READ;
  TRANSACTION
  {
    REQUEST
    {
    }
    REPLY
    {
       aofb_3_actual_mode,
       aofb_3_permitted_mode,
       aofb_3_normal_mode
    }
  }
}
/*---------------------------------------------------------------------*/
COMMAND read_aofb_3_alarm
{
  BLOCK aofb_3;
  INDEX 7;
  OPERATION READ;
  TRANSACTION
  {
    REQUEST
    {
    }
    REPLY
    {
      aofb_3_current_state_alarm_sum,
      aofb_3_unacknowledged_state_alarm_sum,
      aofb_3_unreported_state_alarm_sum,
      aofb_3_disabled_state_alarm_sum
    }
  }
}
/*---------------------------------------------------------------------*/
COMMAND read_aofb_3_batch_information
{
  BLOCK aofb_3;
  INDEX 8;
  OPERATION READ;
  TRANSACTION
  {
    REQUEST
    {
    }
    REPLY
    {
      aofb_3_batch_id,
      aofb_3_batch_unit,
      aofb_3_batch_operation,
      aofb_3_batch_phase
    }
  }
}

COMMAND write_aofb_3_batch_information
{
  BLOCK aofb_3;
  INDEX 8;
  OPERATION WRITE;
  TRANSACTION
  {
    REQUEST
    {
      aofb_3_batch_id,
      aofb_3_batch_unit,
      aofb_3_batch_operation,
      aofb_3_batch_phase
    }
    REPLY
    {
    }
  }
}
/*---------------------------------------------------------------------*/
/*    Function Parameter (9-38)                      */
/*---------------------------------------------------------------------*/
COMMAND read_aofb_3_setpoint
{
  BLOCK aofb_3;
  INDEX 9;
  OPERATION READ;
  TRANSACTION
  {
    REQUEST
    {
    }
    REPLY
    {
      aofb_3_setpoint_value,
      aofb_3_setpoint_status
    }
  }
}

COMMAND write_aofb_3_setpoint
{
  BLOCK aofb_3;
  INDEX 9;
  OPERATION WRITE;
  TRANSACTION
  {
    REQUEST
    {
      aofb_3_sp_value,
      aofb_3_sp_status
    }
    REPLY
    {
    }
  }
}

COMMAND read_aofb_3_pv
{
  BLOCK aofb_3;
  INDEX 11;
  OPERATION READ;
  TRANSACTION
  {
    REQUEST
    {
    }
    REPLY
    {
      aofb_3_pv_upper_range_value,
      aofb_3_pv_lower_range_value,
      aofb_3_pv_unit,
      aofb_3_pv_decimal_point
    }
  }
}

COMMAND write_aofb_3_pv
{
  BLOCK aofb_3;
  INDEX 11;
  OPERATION WRITE;
  TRANSACTION
  {
    REQUEST
    {
      aofb_3_pv_upper_range_value,
      aofb_3_pv_lower_range_value,
      aofb_3_pv_unit,
      aofb_3_pv_decimal_point
    }
    REPLY
    {
    }
  }
}

COMMAND read_aofb_3_readback
{
  BLOCK aofb_3;
  INDEX 12;
  OPERATION READ;
  TRANSACTION
  {
    REQUEST
    {
    }
    REPLY
    {
      aofb_3_readback_value,
      aofb_3_readback_status
    }
  }
}


COMMAND read_aofb_3_rcas_in
{
  BLOCK aofb_3;
  INDEX 14;
  OPERATION READ;
  TRANSACTION
  {
    REQUEST
    {
    }
    REPLY
    {
      aofb_3_rcas_in_value,
      aofb_3_rcas_in_status
    }
  }
}

COMMAND write_aofb_3_rcas_in
{
  BLOCK aofb_3;
  INDEX 14;
  OPERATION WRITE;
  TRANSACTION
  {
    REQUEST
    {
      aofb_3_rcas_in_value,
      aofb_3_rcas_in_status
    }
    REPLY
    {
    }
  }
}

COMMAND read_aofb_3_in_channel
{
  BLOCK aofb_3;
  INDEX 21;
  OPERATION READ;
  TRANSACTION
  {
    REQUEST
    {
    }
    REPLY
    {
      aofb_3_in_channel
    }
  }
}

COMMAND write_aofb_3_in_channel
{
  BLOCK aofb_3;
  INDEX 21;
  OPERATION WRITE;
  TRANSACTION
  {
    REQUEST
    {
      aofb_3_in_channel
    }
    REPLY
    {
    }
  }
}

COMMAND read_aofb_3_out_channel
{
  BLOCK aofb_3;
  INDEX 22;
  OPERATION READ;
  TRANSACTION
  {
    REQUEST
    {
    }
    REPLY
    {
      aofb_3_out_channel
    }
  }
}

COMMAND write_aofb_3_out_channel
{
  BLOCK aofb_3;
  INDEX 22;
  OPERATION WRITE;
  TRANSACTION
  {
    REQUEST
    {
      aofb_3_out_channel
    }
    REPLY
    {
    }
  }
}

COMMAND read_aofb_3_fsafe_time
{
  BLOCK aofb_3;
  INDEX 23;
  OPERATION READ;
  TRANSACTION
  {
    REQUEST
    {
    }
    REPLY
    {
      aofb_3_fsafe_time
    }
  }
}

COMMAND write_aofb_3_fsafe_time
{
  BLOCK aofb_3;
  INDEX 23;
  OPERATION WRITE;
  TRANSACTION
  {
    REQUEST
    {
      aofb_3_fsafe_time
    }
    REPLY
    {
    }
  }
}

COMMAND read_aofb_3_fsafe_type
{
  BLOCK aofb_3;
  INDEX 24;
  OPERATION READ;
  TRANSACTION
  {
    REQUEST
    {
    }
    REPLY
    {
      aofb_3_fsafe_type
    }
  }
}

COMMAND write_aofb_3_fsafe_type
{
  BLOCK aofb_3;
  INDEX 24;
  OPERATION WRITE;
  TRANSACTION
  {
    REQUEST
    {
      aofb_3_fsafe_type
    }
    REPLY
    {
    }
  }
}

COMMAND read_aofb_3_fsafe_value
{
  BLOCK aofb_3;
  INDEX 25;
  OPERATION READ;
  TRANSACTION
  {
    REQUEST
    {
    }
    REPLY
    {
      aofb_3_fsafe_value
    }
  }
}

COMMAND write_aofb_3_fsafe_value
{
  BLOCK aofb_3;
  INDEX 25;
  OPERATION WRITE;
  TRANSACTION
  {
    REQUEST
    {
      aofb_3_fsafe_value
    }
    REPLY
    {
    }
  }
}

COMMAND read_aofb_3_rcas_out
{
  BLOCK aofb_3;
  INDEX 27;
  OPERATION READ;
  TRANSACTION
  {
    REQUEST
    {
    }
    REPLY
    {
      aofb_3_rcas_out_value,
      aofb_3_rcas_out_status
    }
  }
}

COMMAND read_aofb_3_current_position
{
  BLOCK aofb_3;
  INDEX 31;
  OPERATION READ;
  TRANSACTION
  {
    REQUEST
    {
    }
    REPLY
    {
      aofb_3_position_discrete_value,
      aofb_3_position_discrete_status
    }
  }
}

COMMAND read_aofb_3_setpoint_deviation
{
  BLOCK aofb_3;
  INDEX 32;
  OPERATION READ;
  TRANSACTION
  {
    REQUEST
    {
    }
    REPLY
    {
      aofb_3_setpoint_deviation
    }
  }
}

COMMAND read_aofb_3_check_back
{
  BLOCK aofb_3;
  INDEX 33;
  OPERATION READ;
  TRANSACTION
  {
    REQUEST
    {
    }
    REPLY
    {
      aofb_3_check_back
    }
  }
}

COMMAND read_aofb_3_check_back_mask
{
  BLOCK aofb_3;
  INDEX 34;
  OPERATION READ;
  TRANSACTION
  {
    REQUEST
    {
    }
    REPLY
    {
      aofb_3_check_back_mask
    }
  }
}

COMMAND read_aofb_3_simulate
{
  BLOCK aofb_3;
  INDEX 35;
  OPERATION READ;
  TRANSACTION
  {
    REQUEST
    {
    }
    REPLY
    {
      aofb_3_simulate_status,
      aofb_3_simulate_value,
      aofb_3_simulation_enabled
    }
  }
}

COMMAND write_aofb_3_simulate
{
  BLOCK aofb_3;
  INDEX 35;
  OPERATION WRITE;
  TRANSACTION
  {
    REQUEST
    {
      aofb_3_simulate_status,
      aofb_3_simulate_value,
      aofb_3_simulation_enabled
    }
    REPLY
    {
    }
  }
}

COMMAND read_aofb_3_increase_close
{
  BLOCK aofb_3;
  INDEX 36;
  OPERATION READ;
  TRANSACTION
  {
    REQUEST
    {
    }
    REPLY
    {
      aofb_3_increase_close
    }
  }
}

COMMAND write_aofb_3_increase_close
{
  BLOCK aofb_3;
  INDEX 36;
  OPERATION WRITE;
  TRANSACTION
  {
    REQUEST
    {
      aofb_3_increase_close
    }
    REPLY
    {
    }
  }
}

COMMAND read_aofb_3_out
{
  BLOCK aofb_3;
  INDEX 37;
  OPERATION READ;
  TRANSACTION
  {
    REQUEST
    {
    }
    REPLY
    {
      aofb_3_out_value,
      aofb_3_out_status
    }
  }
}

COMMAND write_aofb_3_out
{
  BLOCK aofb_3;
  INDEX 37;
  OPERATION WRITE;
  TRANSACTION
  {
    REQUEST
    {
      aofb_3_out_value,
      aofb_3_out_status
    }
    REPLY
    {
    }
  }
}

COMMAND read_aofb_3_out_scale
{
  BLOCK aofb_3;
  INDEX 38;
  OPERATION READ;
  TRANSACTION
  {
    REQUEST
    {
    }
    REPLY
    {
      aofb_3_out_upper_range_value,
      aofb_3_out_lower_range_value,
      aofb_3_out_unit,
      aofb_3_out_decimal_point
    }
  }
}

COMMAND write_aofb_3_out_scale
{
  BLOCK aofb_3;
  INDEX 38;
  OPERATION WRITE;
  TRANSACTION
  {
    REQUEST
    {
      aofb_3_out_upper_range_value,
      aofb_3_out_lower_range_value,
      aofb_3_out_unit,
      aofb_3_out_decimal_point
    }
    REPLY
    {
    }
  }
}

